; GW48_5_ASM on J14
; 11th February 1999
;
; An ASSEMBLER program
;   PART 5
;
;  SUB ROUTINES
;
; Altered - 11th February 1999 (v4.6)
; BEEP2 added to close more _TMP etc files
;
; TST_SEP altered to table lookup - 23rd January 1999
;
; GLABB & AGLB altered to GSP correctly - Jan 99
;
; Altered error message 82 - Dec 98
;
;
;
; GLAB
; At entry:
;  A1 -> LABEL A2 -> BLSTCK
;
; At exit:
;  LAB VALUE is set & EQU cancelled unless XREF in list
;   when label is set to pseudo-XREF
;  LAB TYPE is set
;  D3.top is set to the section of underlying labels
;
;  If error: Type is set to 3 & D0 = -1
;  If pseudo-XREF:              D0 = -2
;  otherwise D0>=0
;
; All other registers (including D3.W) are preserved
;
GLAB	MOVEM.L	D1-2/D5-7/A3-4,-(A7)
	CMPA.L	G_LIMIT(A6),A7
	BLT	QER35     ---->     not enough space on stack
	MOVEA.L	VAL(A1),A3          EQU table pointer
	MOVE.W	D3,D5     keep D3.W
	MOVEQ	#0,D7     to set bit 31 = 0
	MOVE.L	(A3)+,D6  constant
	MOVE.W	(A3)+,D7  S(PC)
GL_LP	MOVE.W	(A3)+,D3  + or - or 0 for end of list
	BEQ	GL_END
	MOVEA.L	A0,A4
	MOVE.W	(A3)+,D1  label no
	BSR	LNPTR     A0 -> LINN
	EXG	A0,A4
	MOVE.W	TYPE(A4),D0
	MOVE.W	D0,D1      keep type in D1
	ANDI.W	#3,D1
	CMPI.W	#3,D1
	BEQ	GL_ERJ    ---->
	BTST	#4,D0
	BNE	GL_ERJ    ----> FP not allowed in EQU list
	BFTST	D0{22:2}
	BNE	GL_ERJ    ----> reg or reg list not allowed
	BTST	#3,D0     EQU list? ...
	BNE	GL_EQU    ... yes
	BTST	#13,D0    XREF? ...
	BNE	GL_XREF   ... yes
	SUBQ.W	#1,D1     0=N 1=PC -1=error
	BMI	GL_ERJ    ---->
	BEQ	GL_DEF    'N' type
	SWAP	D3        D3.W = sect no or -1
	MOVE.W	(A4),D2   sect no of label
	TST.W	D3
	BMI.S	GL_3      1st PC type (or section -1)
	CMP.W	D2,D3
	BEQ.S	GL_4      same section
	SWAP	D3
	BRA	GL_XREF   ---->
GL_3	MOVE.W	D2,D3     set section
GL_4	SWAP	D3
	BTST	#2,D0     defined? ...
	BNE	GL_DEF    ... yes
	BRA	GL_ERJ    ---->
;
GL_EQU	MOVE.W	-2(A3),D0 label no
	MOVEA.L	BLSTCK(A6),A5
GL_1	CMPA.L	A2,A5
	BGE.S	GL_2
	CMP.W	(A5)+,D0
	BNE.S	GL_1
	BRA	GL_ERJ ---->
GL_2	MOVE.W	D0,(A2)+
	MOVE.L	A1,-(A7)
	MOVEA.L	A4,A1
	BSR	GLAB
	MOVEA.L	(A7)+,A1
	BMI	GL_ERJ2   error or XREF
GL_5	BFEXTU	7(A4){6:1},D1       D1=0 for N, 1 for PC
;
GL_DEF	TST.W	D3       plus?
	BPL.S	GL_PLUS   yes
	SUB.L	VAL(A4),D6
	SUB.W	D1,D7
	BRA	GL_LP
GL_PLUS	ADD.L	VAL(A4),D6
	ADD.W	D1,D7
	BRA	GL_LP
;
GL_END	TST.L	D7
	BMI	GL_XEND   XREF in list
	MOVEQ	#5,D0
	CMPI.W	#0,D7     PC or N?
	BEQ.S	GL_FIVE   N
	CMPI.W	#1,D7     PC or error
	BEQ.S	GL_SIX
	ADDQ.W	#1,D0     set D0 = 7
GL_SIX	SWAP	D3        to get section
	MOVE.W	D3,(A1)   set section
	SWAP	D3
	ADDQ.W	#1,D0
GL_FIVE	ANDI.B	#$F2,TYPE+1(A1)
	OR.B	D0,TYPE+1(A1)
	MOVE.L	D6,VAL(A1)
	BFEXTS	TYPE+1(A1){6:2},D1
	ADDQ.L	#1,D1
	BNE	GL_FIVE1	OK
	MOVEQ	#7,D0	set ERROR
GL_FIVE1	SUBQ.W	#6,D0
	NEG.W	D0
GL_XT	MOVE.W	D5,D3     restore D3.W
	MOVEM.L	(A7)+,D1-2/D5-7/A3-4
	TST.W	D0	set condition codes
	RTS
;
GL_XEND	BFEXTU	TYPE(A1){2:2},D0
	SUBQ.L	#1,D0		XDEF? . .
	BEQ	GL_ERJ    ---->     . . . yes
	CMPI.W	#0,D7
	BEQ.S	GL_XEND1  N
	CMPI.W	#1,D7
	BEQ.S	GL_XEND2  PC
	MOVEQ	#7,D0
	MOVE.W	D0,TYPE(A1)         set error
	BRA	GL_FIVE1
GL_XEND2	OR.W	#$B00A,TYPE(A1)
	BRA	GL_XEND3
GL_XEND1	OR.W	#$B009,TYPE(A1)
GL_XEND3	MOVEQ	#-2,D0
	BRA	GL_XT
;
GL_ERJ2	ADDQ.W	#1,D0
	BEQ.S	GL_ERJ
	BSET	#31,D7    mark XREF been
	BRA	GL_5
;
GL_XREF	BSET	#31,D7    mark XREF been
	BTST	#0,D0
	BNE	GL_LP     'N' label
	ADD.W	D3,D7     S(PC)
	BRA	GL_LP
;
GL_ERJ	MOVEQ	#7,D0
	BRA.S	GL_FIVE
;
; STRG (Uses D2)
;
; ENTRIES:-
;  STRGAx as for STRGx  ("." is a separator)
;  STRGx                ("." is not a separator)
;
; IN:-   A1 x = blank
;        |  A1 x = 1
;  _______________________________ ______
; |      | string to be entered | * |
; |______|__|___________________|_/_|______
;                                /  
; ENTER,SPACE,( ) + - * , . /  (* Separator)
;                                  |
; OUT:-                       D0.B  A1
;  ____________________________
; | Len | string entered       |
; |_____|______________________|
; 
; A2
;
STRGA1	SUBQ.L	#1,A1
STRGA	MOVEQ	#-1,D0    mark '.' is a separator
	BRA.S	ST_1
STRG1	SUBQ.L	#1,A1     reset A1
STRG	MOVEQ	#0,D0     mark '.' not a separator
ST_1	LEA	BUF+2(A6),A2
	MOVE.W	#BUF_SIZE,D2
ST_L	MOVE.B	(A1)+,D0
	BTST	#0,DIP(A6)    if 'on' distinguish cases
	BNE.S	ST_L1
	CMPI.B	#'a',D0
	BLT.S	ST_L1
	CMPI.B	#'z',D0
	BGT.S	ST_L1
	BCLR	#5,D0     set 'a' to 'z' to upper case
ST_L1	TST.W	D0
	BPL.S	ST_2      '.' not sep
	PEA	ST_3
	BRA	TST_SEPA	'.' is a separator . .
ST_2	BSR	TST_SEP	. . is not
ST_3	BEQ.S	GI_END
	MOVE.B	D0,(A2)+
	DBF	D2,ST_L
	MOVEQ	#-1,D0
	BRA.S	GI_EXIT ---->
GI_END	NEG.W	D2
	ADDI.W	#BUF_SIZE,D2
	LEA	BUF(A6),A2
	MOVE.W	D2,(A2)
GI_EXIT	RTS
;
; As STRG but pads BUF with 32 zeros
;
ML_ST	LEA	BUF(A6),A2
	MOVEQ	#7,D0
ML_ST1	CLR.L	(A2)+
	DBF	D0,ML_ST1
	BRA	STRG
;
; TST_SEPA sets Z if D0 is on the list & not-Z otherwise
; TST_SEP is the same as TST_SEPA except that '.' is not on the list
;
;  List is "TAB ENTER SPACE ( ) * + , - . / { } [ ] : & < > !"
;
;  D0 is used but D0.B is preserved
;
TST_SEP	CMPI.B	#".",D0
	BEQ	TS_DO
;
TST_SEPA	MOVE.L	D0,-(A7)		keep D0.31 for STRG
	ANDI.L	#$FF,D0	keep byte
	BFTST	SEP_TAB{D0:1}
	MOVEM.L	(A7)+,D0		restore D0.31
	RTS
;
TS_DO	MOVE	#0,CCR
	RTS
;
; In SEP_TAB each bit represents a byte and if on means 'separator'
;
SEP_TAB	DC.W	$FF9F,-1,$3D00,$FFD5
	DC.W	-1,$FFEB,-1,$FFEB
	DCB.L	4,-1
;
; DEC sets a decimal number from LBUF (A1) to D5.L
; D0 is the separator or -1 if an error
; A1 -> the next character after the separator
;
DEC	MOVEQ	#0,D5
	BRA.S	DEC_S
DEC_T	MOVE.B	(A1)+,D0
	BSR.S	TST_SEP
	BEQ.S	DC_END
DEC_S	SUBI.B	#48,D0
	BMI.S	WRN_DC ---->
	CMPI.B	#9,D0
	BGT.S	WRN_DC ---->
	AND.L	#15,D0
	ADD.L	D5,D5
	BVS.S	WRN_DC ---->
	ADD.L	D5,D0
	BVS.S	WRN_DC ---->
	ASL.L	#2,D5
	BVS.S	WRN_DC ---->
	ADD.L	D0,D5
	BVC.S	DEC_T
WRN_DC	MOVEQ	#-1,D0
DC_END	RTS
;
; HEX - as for DEC but converts hex -> decimal
;
HEX	MOVEM.L	D1/D2,-(A7)
	MOVEQ	#8,D1
	MOVEQ	#0,D5
HX_L	MOVE.B	(A1)+,D0  next byte
	BSR	TST_SEP
	BEQ.S	HX_END
	SUBI.B	#"0",D0
	BMI.S	WRN_HX ---->
	CMPI.B	#9,D0
	BLE.S	D_HX
	SUBQ.B	#7,D0
	CMPI.B	#16,D0
	BLT.S	HX_1      capitals
	SUBI.B	#32,D0
HX_1	CMPI.B	#10,D0
	BLT.S	WRN_HX ---->
	CMPI.B	#15,D0
	BGT.S	WRN_HX ---->
D_HX	LSL.L	#4,D5     prepare for next nibble
	OR.B	D0,D5     put it in
	DBF	D1,HX_L
WRN_HX	MOVEQ	#-1,D0
HX_END	MOVEM.L	(A7)+,D1/D2
	RTS
;
; RAS puts the ASCII string in quotes to BUF
; if the length is less than 5 the number is
; put in D5.L
;
RAS	MOVEM.L	D1-2,-(A7)
	MOVEM.L	D3/A2,-(A7)
	MOVE.B	D0,D2 separator ' or "
	MOVEQ	#0,D5
	LEA	BUF+2(A6),A2
	MOVEQ	#BUF_SIZE,D3
RAS_1	MOVE.B	(A1)+,D0
	CMP.B	D2,D0     end?
	BEQ.S	RAS_2     yes
	MOVE.B	D0,(A2)+
	DBF	D3,RAS_1
RAS_ER	ADDQ.L	#8,A7
	BRA.S	WRN_HX ---->
RAS_2	MOVE.B	(A1)+,D0  next character
	BSR	TST_SEP
	BMI.S	RAS_ER ---->
	NEG.W	D3
	ADDI.W	#BUF_SIZE,D3
	LEA	BUF(A6),A2
	MOVE.W	D3,(A2)
	CMPI.W	#4,D3
	BGT.S	RAS_3
	NEG.W	D3
	ADDQ.W	#4,D3
	LSL.W	#3,D3     32-8*D3
	MOVE.L	2(A2),D5
	LSR.L	D3,D5     right justify
RAS_3	MOVEM.L	(A7)+,D3/A2
	BRA.S	HX_END
;
; BI - as for DEC but converts binary -> decimal
;
BI	MOVEM.L	D1,-(A7)  'movem' is used to preserve cond codes
	MOVEQ	#0,D5     prepare D5
	MOVEQ	#33,D1    allow only 32 bits (33rd char is sep)
	BRA.S	BI_3
BI_4	CMPI.B	#"1",D0
	BEQ.S	BI_1
	CMPI.B	#"0",D0
	BNE.S	BI_2
	LSL.L	#1,D5     shift up D5
	BRA.S	BI_3
BI_1	LSL.L	#1,D5
	ADDQ.L	#1,D5     add a bit
BI_3	MOVE.B	(A1)+,D0  next character
	DBF	D1,BI_4   count up to 32
BI_6	MOVEQ	#-1,D0    mark error
BI_5	MOVEM.L	(A7)+,D1  leave cond codes unchanged
	RTS
BI_2	BSR	TST_SEP
	BEQ.S	BI_5      good exit
	BRA.S	BI_6      bad character in binary
;
; PUT_W puts D5.W to output buffer O_BUF
;
PUT_W	MOVEM.L	D0/D3/A0-3,-(A7)
	LEA	O_BEND(A6),A0
	MOVE.L	A0,D0
	MOVEA.L	O_BUF(A6),A0
	SUB.L	A0,D0     space left
	SUBQ.L	#2,D0     room for 2?
	BEQ	PUT_W2    B=-1, W=0 more >0
	BMI	PUT_W1
	MOVE.W	D5,(A0)+  put it in
	MOVE.L	A0,O_BUF(A6)   update pointer
PUT_W3	MOVEM.L	(A7)+,D0/D3/A0-3
	RTS
PUT_W1	ROR.W	#8,D5     swap bytes
	MOVE.B	D5,(A0)+  byte ->
	BSR	FLUSH
	ROR.W	#8,D5     restore D5
	MOVE.B	D5,(A2)+  2nd byte ->
	MOVE.L	A2,(A1)   update pointer
	BRA.S	PUT_W3
PUT_W2	MOVE.W	D5,(A0)+
	BSR	FLUSH
	BRA	PUT_W3
;
; FLUSH1 flushes O_BUF even if not full
; FLUSH  flushes O_BUF from A0
;
FLUSH1	MOVEA.L	O_BUF(A6),A0   current position to A0
FLUSH	MOVE.L	CH_OUT(A6),D0
	TST.B	BIN_SWTCH(A6)
	BEQ.S	GFLUSH     PASS1
	TST.B	REL_SWTCH(A6)
	BEQ.S	FLUSH2    normal
	MOVE.L	CH_OUT1(A6),D0      ID for _o
	BRA	GFLUSH
FLUSH2	MOVEM.L	D1/A0/A3,-(A7)
	MOVEA.L	CH_OUT(A6),A0
	MOVEQ	#0,D1
	MOVEQ	#-1,D3
	MOVEQ	#FS_POSRE,D0
	TRAP	#3
	MOVE.L	D1,BIN_IN(A6)   store current position for input
	MOVE.L	BIN_OUT(A6),D1  get position for output
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	MOVEM.L	(A7)+,D1/A0/A3
	MOVE.L	CH_OUT(A6),D0
	BSR.S	GFLUSH
	MOVE.L	D1,-(A7)
	MOVE.L	BIN_IN(A6),D1
	MOVEQ	#FS_POSAB,D0
	TRAP	#3        restore input position
	MOVE.L	(A7)+,D1  restore D1
	RTS
;
;  On entry D0 = CH_OUT or CH_OUT1: this is in A0 on exit
;
GFLUSH	MOVEM.L	D1/D2,-(A7)
	LEA	O_BUF+2(A6),A1
	EXG	D0,A0
	SUB.L	A1,D0     No of bytes
	SUBQ.W	#2,D0     adjust to length
	BEQ.S	FLEND
	MOVE.W	D0,(A1)   set length of string
	BSR	UMT1
	TST.L	D0
	BNE	QER9      ---->
	MOVEQ	#0,D1
	MOVEQ	#FS_POSRE,D0
	TRAP	#3
	MOVE.L	D1,BIN_OUT(A6)   update output position
	LEA	O_BUF(A6),A1
	LEA	4(A1),A2
	MOVE.L	A2,(A1)
FLEND	MOVEM.L	(A7)+,D1/D2
	RTS
;
; PUT_B is the same as PUT_W but puts a byte
;
PUT_B	MOVEM.L	D0/D3/A0-3,-(A7)
	LEA	O_BEND(A6),A0
	MOVE.L	A0,D0
	LEA	O_BUF(A6),A1
	MOVEA.L	(A1),A0   pointer -> A0
	MOVE.B	D5,(A0)+  put it in
	MOVE.L	A0,(A1)   update pointer
	CMPA.L	D0,A0     end?
	BLT.S	NOFLB      no
	BSR	FLUSH
NOFLB	MOVEM.L	(A7)+,D0/D3/A0-3
	RTS
;
; Puts D2.W bytes from (A3) to O_BUF adding extra FB when needed
;
PFPUT	MOVEM.L	D0/D2-3/D5/D7/A0-4,-(A7)
	MOVEA.L	A3,A4
	LEA	O_BEND(A6),A0
	MOVE.L	A0,D7
	MOVEQ	#0,D5
PFPUT1	MOVEA.L	(O_BUF,A6),A0     pointer
PFPUT2	BCLR	#15,D5
	BNE.S	PFPUT4    do 2nd time
	MOVE.B	(A4)+,D5
	DBF	D2,PFPUT3
	MOVE.L	A0,O_BUF(A6)        update pointer
	MOVEM.L	(A7)+,D0/D2-3/D5/D7/A0-4
	RTS
;
PFPUT3	CMPI.B	#$FB,D5
	BNE.S	PFPUT4
	TST.B	REL_SWTCH(A6)
	BEQ.S	PFPUT4    don't put extra FB if not _o!!
	BSET	#15,D5    prepare for extra FB
PFPUT4	MOVE.B	D5,(A0)+
	CMPA.L	D7,A0
	BLT	PFPUT2    buffer not empty
	BSR	FLUSH
	BRA	PFPUT1
;
; Puts 2 bytes from (A3,D0.W) to output adding FB if needed.
; Uses no registers
;
PGPUT	MOVEM.L	D2/A3,-(A7)
	MOVEQ	#2,D2
PGPUT1	LEA	(A3,D0.W),A3
	BSR	PFPUT
	MOVEM.L	(A7)+,D2/A3
	RTS
;
; Sends one byte from D5 adding FB if needed
;
PHPUT	MOVEM.L	D5/D2/A3,-(A7)
	MOVEQ	#1,D2	number of bytes to send
	LEA	7(A7),A3	-> D5.B
	BSR	PFPUT
	MOVEM.L	(A7)+,D2/D5/A3
	RTS
;
; Puts string @ A1 (with BYTE count) to output (exact copy)
; Uses no registers
;
PXPUT	MOVEM.L	D0/D2/D3/D7/A0-3,-(A7)
	MOVEQ	#0,D2
	MOVE.B	(A1)+,D2  D2.W = count
PXPUT1	LEA	O_BEND(A6),A0    end of buffer
	MOVE.L	A0,D7
	MOVEA.L	(O_BUF,A6),A0     pointer
	SUB.L	A0,D7     free space -> D7
	CMP.W	D7,D2
	BLT.S	PXPUT2    room for this
	SUB.W	D7,D2     remaining bytes
	BRA.S	PXPUT3
PXPUT4	MOVE.B	(A1)+,(A0)+
PXPUT3	DBF	D7,PXPUT4 fill buffer . . .
	MOVE.L	A1,-(A7)
	BSR	FLUSH     . . . and send it
	MOVEA.L	(A7)+,A1
	BRA.S	PXPUT1
PXPUT5	MOVE.B	(A1)+,(A0)+
PXPUT2	DBF	D2,PXPUT5
	MOVE.L	A0,O_BUF(A6)   update pointer
	MOVEM.L	(A7)+,D0/D2/D3/D7/A0-3
	RTS
;
; EXTENS extends the length of CH_LST etc
;  On entry A1 -> the list pointer, the current length and the increment
;           D0.L = space needed
;           A6 -> DATA SPACE
;           $10(A7) < 0 no relocation : space -> -1
;                   = 0 no relocation
;                   = 1 relocation @ 1st longword of space
;                   = 2 relocation @ each 6*k+2 longword of _IX space
;
;  On exit  Pointer and current length are updated. If needed the old list
;           is copied to the new place and space returned to the user heap.
;           Also space is set to -1 if wanted.
;  No registers are used.
;
EXTENS	MOVEM.L	D0-3/A0-3,-(A7)
	MOVE.L	4(A1),D2  old length
	MOVE.L	8(A1),D1  increment-1
	ADD.L	D1,D0	round to . .
	NOT.L	D1	. . increment
	AND.L	D0,D1     new length needed
	BSR	NN_LG2    get address of new space to A0
	BNE	QER4      ---->
	MOVEA.L	(A1),A2   current address
	MOVEA.L	A2,A3
	MOVE.L	A0,(A1)   set new address in DATA SPACE
	MOVE.L	D1,4(A1)  set new length
	MOVE.L	$30(A7),D0
	BPL	EXTENS6   don't set to -1
	LSR.W	#2,D1     total new length/4
	BRA	EXTENS7
EXTENS8	MOVE.L	#-1,(A0)+
EXTENS7	DBF	D1,EXTENS8
	MOVEA.L	(A1),A0   reset A0
EXTENS6	MOVE.L	D2,D1     old length (set for release)
	BEQ	EXTENS4   no old list
	MOVE.L	A0,D3
	SUB.L	A2,D3
	SUBQ.L	#1,D0
	BMI	EXTENS5	no relocation
	BNE	EXTENS9	relocation 2
	ADD.L	D3,(A2)	relocation 1
EXTENS5	LSR.L	#2,D2     no of long words
	BRA	EXTENS1
EXTENS2	SWAP	D2
EXTENS3	MOVE.L	(A2)+,(A0)+
EXTENS1	DBF	D2,EXTENS3
	SWAP	D2
	DBF	D2,EXTENS2
	MOVEA.L	A3,A0     old address
	LEA	HEAPAD(A6),A1
	MOVEA.W	MM_LNKFR,A2
	JSR	(A2)
EXTENS4	MOVEM.L	(A7)+,D0-3/A0-3
	RTS
;
EXTENS9	MOVE.L	XREF_IX(A6),D0
	LEA	2(D0.L),A0	1st address
	ADD.L	IX_LEN(A6),D0	+l
	SUBQ.L	#4,D0		last address
	BRA	EXTENS10
EXTENS11	ADD.L	D3,(A0)		add adjustment
	ADDQ.L	#6,A0		to next entry
EXTENS10	CMPA.L	D0,A0
	BLE	EXTENS11		more to do
	MOVEA.L	(A1),A0		reset A0
	BRA	EXTENS5
;
; GBINS checks there is space for another INSERT. If not it
;       gets another chunk and updates the pointers.
;
;       A0 is used.
;
GBINS	MOVEM.L	D0-1,-(A7)
	MOVE.L	BINS(A6),D0         pointer to next free space
	BEQ	GBINS_1   1st time
	MOVEA.L	D0,A0
	SUB.L	(A0),D0
	ADDI.L	#BIN_INC_S-18,D0
	BGE	GBINS_3   OK
	MOVE.L	-8(A0),D0 pointer to next block
	BEQ	GBINS_4   new block needed
	MOVEA.L	D0,A0
	BRA	GBINS_2
;
GBINS_4	CLR.L	-(A7)     mark not 1st time
GBINS_5	MOVE.L	#BIN_INC_S,D1      length of chunk
	BSR	NN_LG2    get chunk (A0)
	BNE	QER4      ---->
	TST.L	(A7)+
	BEQ	GBINS_6   not 1st time
	MOVE.L	A0,BIN_F(A6)        set address of 1st chunk
	BRA	GBINS_2
;
GBINS_6	MOVE.L	A0,([BINS,A6],-8)   set 'next chunk' in old chunk
	MOVE.L	BINS(A6),D0
	SUBQ.L	#8,D0     address of old chunk
	MOVE.L	D0,4(A0)  put into new one
GBINS_2	MOVE.L	A0,BIN_L(A6)        set last chunk address
	ADDQ.L	#8,A0
	MOVE.L	A0,BINS(A6)         set current chunk
	ADDQ.L	#4,A0
	MOVE.L	A0,-4(A0)           set pointer
GBINS_3	MOVEM.L	(A7)+,D0-1
	RTS
;
GBINS_1	MOVE.L	BIN_F(A6),D0
	BEQ	GBINS_7   no block obtained
	MOVEA.L	D0,A0
	BRA	GBINS_2
GBINS_7	PEA	1         mark 1st time
	BRA	GBINS_5
;
; FIND
; IN: A0 -> list of items {len|item} ending with len=0
;     A1 -> thing to be compared 'len|item'
;     D1 = No of items in list -1
;
; OUT: D1.W = No of item in list -1 or -1 if not in list
;      uses no other register
;
FIND	MOVEM.L	D0/D2-4/A0/A2/A3,-(A7)
	MOVE.W	(A1),D0   length
	MOVE.W	D1,D4
;
FND2	MOVE.W	A0,D2
	BTST	#0,D2     even address?
	BEQ.S	FND_E
	ADDQ.L	#1,A0     adjust to WORD
FND_E	MOVE.W	(A0)+,D2  item's length
	LEA	(A0,D2.W),A3    A3 -> next item
	CMP.W	D2,D0     compare lengths
	BNE.S	FND3      different
	MOVE.W	D0,D3
	LEA	2(A1),A2  A2 -> start of item
	SUBQ.W	#1,D3
FND5	CMPM.B	(A2)+,(A0)+
	DBNE	D3,FND5   compare string
FND3	MOVEA.L	A3,A0     next item
	DBEQ	D1,FND2   go through items till equal
	BNE.S	FNDX      not found (D1.W = -1)
	SUB.W	D4,D1
	NEG.W	D1
FND1	MOVEM.L	(A7)+,D0/D2-4/A0/A2/A3
	RTS
FNDX	MOVEQ	#-1,D1
	BRA.S	FND1
;
; FIND1 subtracts 1 from counts over 15. This allows 'SP' to be taken
; as 'A7'.
;
FIND1	BSR	FIND
	BMI	F_SPOUT
	SUBI.W	#16,D1
	BMI	F_SPOUT1
	SUBQ.W	#1,D1
F_SPOUT1	ADDI.W	#16,D1
F_SPOUT	RTS
;
; CH_LET sets D0.L=0 if D0.B is a-z,A-Z or _ (or . not followed by 0-9)
;                 =-1 otherwise
;
CH_LET	CMPI.B	#"_",D0
	BEQ.S	CH_LET1
	CMPI.B	#".",D0
	BEQ.S	CH_LET2
	CMPI.B	#91,D0
	BLT.S	CAPS
	SUBI.B	#32,D0
CAPS	CMPI.B	#65,D0
	BLT.S	CH_NOT
	CMPI.B	#90,D0
	BGT.S	CH_NOT
CH_LET1	MOVEQ	#0,D0
COUT	RTS
CH_LET2	MOVE.B	(A1),D0   next character
	CMPI.B	#"0",D0
	BLT	CH_LET1   not 0-9
	CMPI.B	#'9',D0
	BGT	CH_LET1   not 0-9
CH_NOT	MOVEQ	#-1,D0
	BRA.S	COUT
;
; DO_ERR puts the error message no (D1.B)
;        to ER_LST, unless it is full
;
DO_ERR	MOVEM.L	D0/A0-2,-(A7)
	MOVEA.L	TER_LST(A6),A2
	MOVEA.L	ER_LST(A6),A0
	MOVE.L	LINE_NO(A6),D0
	MOVEA.L	(A0),A1
DO_ERR2	SUBQ.L	#6,A1     previous entry
	CMPA.L	A0,A1
	BLT.S	DO_ERR1   no more entries
	CMP.L	(A1),D0   This line?
	BNE.S	DO_ERR1   no
	CMP.W	4(A1),D1  same error no?
	BEQ.S	NO_ER     yes - don't repeat it
	BRA.S	DO_ERR2
DO_ERR1	MOVEA.L	(A0),A1
	CMPA.L	A2,A1
	BGE.S	NO_ER
	MOVE.L	D0,(A1)+
	MOVE.W	D1,(A1)+
	MOVE.L	A1,(A0)
NO_ER	MOVEM.L	(A7)+,D0/A0-2
	RTS
;
; LTOD sets ASCII decimal for D0.L in
; a buffer indicated by A0 (and uses D1).
;
; At entry:
;   D0.L contains the (positive) number.
;   A0 points to the end of the area to
;   contain the ASCII decimal.
;
; At exit:
;   D0 = 0
;   A0 points to the start of the number.
;
LTOD	SWAP	D0
	BEQ.S	LTODW2
	MOVE.W	D0,D1
	BEQ.S	LTODW
	EXT.L	D1
	DIVU	#10,D1
	SWAP	D1
	MOVE.W	D1,D0
	SWAP	D0
	DIVU	#10,D0
	SWAP	D0
	ADDI.W	#48,D0
	MOVE.B	D0,-(A0)
	SWAP	D0
	MOVE.W	D0,D1
	MOVE.L	D1,D0
	BRA.S	LTOD
LTODW1	DIVU	#10,D0
	SWAP	D0
LTODW2	ADDI.W	#48,D0
	MOVE.B	D0,-(A0)
	CLR.W	D0
LTODW	SWAP	D0
	BNE.S	LTODW1
	RTS
;
; LTODZ sets the (signed) number in D0
; to (A2) - ASCII and no advance spaces.
; A negative number is preceded by "-".
;
; LTODZ uses LTOD
;
LTODZ	TST.L	D0
	BPL	LTODZ_1
	NEG.L	D0
	MOVE.B	#"-",(A2)+
LTODZ_1	LEA	10(A2),A0
	BSR	LTOD
	MOVEQ	#10,D1
	ADD.L	A2,D1
	SUB.L	A0,D1     length
	BRA	LTODZ_2
LTODZ_3	MOVE.B	(A0)+,(A2)+
LTODZ_2	DBF	D1,LTODZ_3
	RTS
;
; GET_FP looks for FPn
;  if found D1.W = n, else cond N is set
;  A1 -> next character : D0.B = separator
;
GET_FP	MOVE.L	A2,-(A7)
	BSR	STRG
	BMI	GET_FPER ---->
	MOVEQ	#7,D1
	EXG	A1,A2
	LEA	FP_LIST,A0
	BSR	FIND
	EXG	A2,A1
	BMI	GET_FPL	it might be a label
GET_FPER	MOVEA.L	(A7)+,A2
	RTS
;
GET_FPL	BSR	NLAB_NO
	BNE	GET_FPER1	---->
	BFEXTU	TYPE(A0){6:2},D1
	SUBQ.B	#2,D1
	BNE	GET_FPER1	---->
	MOVE.L	VAL(A0),D1	as from FIND1 with D_LIST
	SUBI.W	#21,D1
	BMI	GET_FPER1	---->	not FPx
	CMPI.W	#7,D1
	BGT	GET_FPER1	---->
	MOVE.B	-1(A1),D0		replace separator
	MOVE	#0,CCR		set OK
	BRA	GET_FPER
;
GET_FPER1	MOVE	#8,CCR		set N
	BRA	GET_FPER
;
; To get D and S FP nos from X @ A0
; (Uses D3 & D4)
;
FP_XD	BSR	FP_Z      test for + or - 0
	BEQ	FP_XDSE   zero
	BFEXTU	4(A0){1:32},D3
	BFEXTS	8(A0){1:20},D4
	BTST	#2,10(A0) guard bit
	BEQ	FP_XDS1   no rounding
	BTST	#1,10(A0) round bit
	BNE	FP_XDS2   round
	BFTST	10(A0){7:9}         sticky bit
	BNE	FP_XDS2   round
	BTST	#0,D4     LSB
	BNE	FP_XDS1   no rounding
FP_XDS2	ADDQ.L	#1,D4     (carry goes up to top)
	BCC	FP_XDS1
	ADDQ.L	#1,D3
	BCC	FP_XDS1   done
	BFEXTU	(A0){1:15},D3       exponent
	SUBQ.W	#1,D3
	BMI	FP_XDS3   set ZERO
	BFINS	D3,(A0){1:15}       reset exponent
	MOVEQ	#0,D3
FP_XDS1	BFINS	D3,4(A0){12:32}
	BFINS	D4,8(A0){12:20}
	BCLR	#7,4(A0)  prepare for + number
	MOVE.W	(A0),D3   EXP
	BPL.S	FP_XDS17
	BSET	#7,4(A0)  in fact it is -
	BCLR	#15,D3
FP_XDS17	SUBI.W	#$3FFF-$3FF,D3     new biassed exp
	BLE	FP_XDS3   ZERO
	CMPI.W	#$7FF,D3
	BGE	FP_XDS4   infinity
	BFINS	D3,4(A0){1:11}
FP_XDS5	CLR.L	(A0)
FP_XDSE	RTS
;
FP_XDS3	MOVEQ	#0,D3     ZERO
	BFINS	D3,4(A0){1:31}
FP_XDS6	CLR.L	8(A0)
	BRA	FP_XDSE
;
FP_XDS4	BTST	#7,4(A0)  INFINITY
	BEQ	FP_XDS13  plus infinity
	MOVE.L	#$FFF00000,4(A0)
	BRA	FP_XDS6
FP_XDS13	MOVE.L	#$7FF00000,4(A0)
	BRA	FP_XDS6
;
; SINGLE SIZE
;
FP_XS	BSR	FP_Z      test for + or  - zero
	BEQ	FP_XS3    zero
	BFEXTS	4(A0){1:23},D3
	BTST	#7,7(A0)  guard bit
	BEQ	FP_XDS7   no rounding
	BTST	#6,7(A0)
	BNE	FP_XDS8   round
	BFTST	7(A0){2:6}          sticky ...
	BNE	FP_XDS8   round
	TST.L	8(A0)               ... bit
	BNE	FP_XDS8   round
	BTST	#0,D3     LSB
	BNE	FP_XDS7   no rounding
FP_XDS8	ADDQ.L	#1,D3
	BCC	FP_XDS7   done
	BFEXTU	(A0){1:15},D3       exponent
	SUBQ.W	#1,D3
	BMI	FP_XDS9   ZERO
	BFINS	D3,(A0){1:15}     replace exponent
	MOVEQ	#0,D3
FP_XDS7	BFINS	D3,8(A0){9:23}
	BCLR	#7,8(A0)  prepare for + number
	BTST	#7,(A0)
	BEQ.S	FP_XDS19
	BSET	#7,8(A0)  in fact it's -
FP_XDS19	BFEXTU	(A0){1:15},D3
	SUBI.W	#$3FFF-$7F,D3       biassed exponent
	BLE	FP_XDS9   ZERO
	CMPI.W	#$FF,D3
	BGE	FP_XDS10  infinity
	BFINS	D3,8(A0){1:8}
FP_XDS11	CLR.L	(A0)+
	CLR.L	(A0)+
FP_XS3	RTS
;
FP_XDS9	MOVEQ	#0,D3     ZERO
FP_XDS12	BFINS	D3,8(A0){1:31}
	BRA	FP_XDS11
;
FP_XDS10	MOVE.L	#$7F800000,D3       INFINITY
	BRA	FP_XDS12
;
FP_XP	BSR	FP_Z      is no + or - 0? . . .
	BEQ	FP_XP17   . . . yes
	MOVEM.L	D0-2/D5-7/A1-4,-(A7)
	MOVEQ	#11,D3    count
	LEA	N1+BUF(A6),A3
FP_XP16	CLR.L	(A3)+
	DBF	D3,FP_XP16
	MOVE.L	4(A0),D1
	BEQ	FP_XPZ    could be zero
	MOVE.L	8(A0),D2  rest of mantissa
	LEA	N1+BUF(A6),A3
	MOVEQ	#1,D3     1st digit
	BFINS	D3,(A3){4:4}
	MOVEQ	#4,D7     pointer to digit
	LSL.L	#1,D1     move over '1'
	LSL.L	#1,D2     move up 1
	BCC.S	FP_XP1
	BSET	#0,D1     put carry to D1
FP_XP1	ADDQ.L	#4,D7     step digits and clear X
	MOVEQ	#0,D0     X not affected
	ADD.L	D2,D2
	ADDX.L	D1,D1
	ADDX.L	D0,D0     2f (X cleared)
	MOVE.L	D0,D3
	MOVE.L	D1,D4
	MOVE.L	D2,D5
	MOVEQ	#1,D6     count
FP_XP2	ADD.L	D2,D2
	ADDX.L	D1,D1
	ADDX.L	D0,D0     (X cleared)
	DBF	D6,FP_XP2
	ADD.L	D5,D2
	ADDX.L	D4,D1
	ADDX.L	D3,D0     (X cleared)
	BFINS	D0,(A3){D7:4}       put in next digit
	TST.L	D1
	BNE	FP_XP1    more
	TST.L	D2
	BNE	FP_XP1
;
; mantissa is in N1
;
	BFEXTU	(A0){1:15},D5       biassed exponent
	SUBI.W	#$3FFF,D5           true 2's exponent
	BMI.S	FP_XP3    negative exponent
	LEA	FP_EP,A4  10's exponents (plus)
	LEA	12+FP_BP,A1         binary powers
	BRA.S	FP_XP4
FP_XP3	LEA	FP_EM,A4  10's exponents (negative)
	LEA	12+FP_BM,A1         binary powers
	NEG.W	D5
FP_XP4	LSR.W	#1,D5     advance thru powers of 2
	BCC	FP_XP5
	ADD.W	(A4),D2   add exponent
	BSR	FP_PM     multiply by 2^(+-2^n) -> N3
	LEA	13+N3+BUF(A6),A3    now round
	LEA	ROUND+13,A2
	MOVEQ	#LN1,D0
FP_XP6	ABCD	-(A2),-(A3)
	DBF	D0,FP_XP6
	BFEXTU	(A3){0:4},D0
	BEQ.S	FP_XP7    OK
	ADDQ.W	#1,D2     adjust 10's exponent
	MOVE.L	#$8000000,(A3)      set no
	CLR.L	4(A3)
	CLR.L	8(A3)
FP_XP7	MOVEQ	#2,D0
	LEA	N3+BUF(A6),A3
	LEA	N1+BUF(A6),A2
FP_XP8	MOVE.L	(A3)+,(A2)+         set rounded answer to N1
	DBF	D0,FP_XP8
FP_XP5	LEA	2(A4),A4  to next exponent
	LEA	12(A1),A1 to next  power
	TST.W	D5
	BNE	FP_XP4    more to be done
;
; Now round the last place of N1 to correct size
;
	LEA	N1+10+BUF(A6),A3
	LEA	ROUND1+10,A2
	MOVEQ	#9,D0
FP_XP9	ABCD	-(A2),-(A3)
	DBF	D0,FP_XP9
	BFEXTU	(A3){0:4},D0        has it got too big? ...
	BEQ.S	FP_XP10             ... no
	ADDQ.W	#1,D2     adjust exponent
	MOVE.L	#$8000000,(A3)      set '1'
	CLR.L	4(A3)
	CLR.L	8(A3)
FP_XP10	CLR.B	2(A0)
;
; Now put N1 to ANS
;
	MOVEQ	#8,D0
	LEA	N1+BUF(A6),A2
	LEA	3(A0),A3
FP_XP11	MOVE.B	(A2)+,(A3)+
	DBF	D0,FP_XP11
;
; Now do exponent
;
	TST.W	D2
	BPL.S	FP_XP12
	BSET	#6,(A0)
	NEG.W	D2
	BRA.S	FP_XP13
FP_XP12	BCLR	#6,(A0)   EXP sign
FP_XP13	BCLR	#4,(A0)   clear ...
	BCLR	#5,(A0)   ... YY
	MOVEQ	#12,D1
FP_XP14	MOVE.W	D2,D0
	EXT.L	D0
	DIVU	#10,D0    get least significant digit
	MOVE.W	D0,D2     get N DIV 10 (for next time)
	SWAP	D0        digit
	BFINS	D0,(A0){D1:4}
	SUBQ.W	#4,D1     to previous digit
	BGT.S	FP_XP14   more to do
	MOVEQ	#0,D0     set CCR zero
FP_XP15	MOVEM.L	(A7)+,D0-2/D5-7/A1-4
FP_XP17	RTS
;
FP_XPZ	MOVE.L	8(A0),D0
	BNE.S	FP_XPER
	BFEXTU	(A0){1:31},D0
	BEQ.S	FP_XP15   OK (+ or - zero)
FP_XPER	MOVEQ	#-1,D0    mark error
	BRA.S	FP_XP15
;
; FP_Z sets Z if FP.X no @ (A0) is + or - 0 and not-Z otherwise
;
FP_Z	TST.L	(A0)
	BEQ	FP_Z1     could be + or - 0
	CMPI.L	#$80000000,(A0)
	BNE	FP_Z2     not zero
FP_Z1	TST.L	4(A0)
	BNE	FP_Z2     not zero
	TST.L	8(A0)
FP_Z2	RTS
;
ROUND	DC.W	0,0,0,0,0,0,$5000
ROUND1	DC.W	0,0,0,0,$50
;
; FP_PM multiplies two 23 digit packed decimal numbers
;
; ENTRY A1 -> end of 1st number (12 bytes)
;       D2 = 10's exponent
;       N1+BUF contains the 2nd no
;
; EXIT N3+BUF contains the answer
;
; Uses D0,D1,D6,D7,A2,A3
;      D2 is updated and A1 is not altered
;
FP_PM	MOVEQ	#2,D0           ***************
	LEA	N1+BUF(A6),A3   *             *
	LEA	N2+BUF(A6),A2   *    Sets     *
FP_PM11	BFEXTU	(A3){4:32},D1   *   N1 x 10   *
	BFINS	D1,(A2){0:32}   *    in N2    *
	LEA	4(A2),A2        *             *
	LEA	4(A3),A3        ***************
	DBF	D0,FP_PM11
	MOVEQ	#0,D0
	BFINS	D0,-1(A2){4:4}       clear last nibble
	MOVEQ	#5,D0
	LEA	N3+BUF(A6),A2
FP_PM1	CLR.L	(A2)+     clear N3
	DBF	D0,FP_PM1
	MOVEQ	#0,D6     pointer to digit
FP_PM6	SUBQ.L	#4,D6     to previous digit
	CMPI.B	#-92,D6   ended? . . .
	BLT.S	FP_PM2    . . . yes
	BFEXTU	(A1){D6:4},D7       next digit
	BRA.S	FP_PM3
FP_PM5	MOVE.W	D6,D0
	ASR.W	#3,D0     byte pointer
	LEA	1+N3+LN2+BUF(A6,D0.W),A2   -> end of byte
	LEA	N1+LN1+BUF(A6),A3        odd (N1)
	BTST	#2,D6
	BNE.S	FP_PM7
	LEA	N2-N1(A3),A3        even (N2)
FP_PM7	MOVEQ	#LN1-1,D0 count
	MOVE	#0,CCR    X -> 0
FP_PM4	ABCD	-(A3),-(A2)         two digits at a time
	DBF	D0,FP_PM4
	BCC.S	FP_PM3
	BTST	#2,D6
	BNE.S	FP_PM3
	ADDQ.B	#1,-1(A2) enter 'carry' if needed
FP_PM3	DBF	D7,FP_PM5 count digits
	BRA.S	FP_PM6
;
; Now normalise
;
FP_PM2	MOVEQ	#2,D1
	LEA	N3+BUF(A6),A3
	BFEXTU	(A3){8:4},D0
	BEQ.S	FP_PM9    move 2 nibbles
FP_PM8	BFEXTU	(A3){4:32},D0       32-bit chunks
	BFINS	D0,(A3){0:32}
	LEA	4(A3),A3 -> next chunk
	DBF	D1,FP_PM8
	MOVEQ	#0,D0
	BFINS	D0,-1(A3){4:4}       clear last nibble
	ADDQ.W	#1,D2     adjust exponent
FP_PM10	RTS
;
FP_PM9	MOVE.L	1(A3),(A3)
	LEA	4(A3),A3
	DBF	D1,FP_PM9
	CLR.B	-1(A3)
	BRA.S	FP_PM10
;
; FP_BM, FP_EM FP_BP and FP_EP are mantissae and exponents
; of powers of 2 in packed notation (more or less)
;
FP_BM	DC.L	$5000000,0,0                  2^(-2^0)
	DC.L	$2500000,0,0                  2^(-2^1)
	DC.L	$6250000,0,0                  2^(-2^2)
	DC.L	$3906250,0,0                  2^(-2^3)
	DC.L	$1525878,$90625000,0          2^(-2^4)
	DC.L	$2328306,$43653869,$62890625  2^(-2^5)
	DC.L	$5421010,$86242752,$21700373  2^(-2^6)
	DC.L	$2938735,$87705571,$87699218  2^(-2^7)
	DC.L	$8636168,$55509444,$46253864  2^(-2^8)
	DC.L	$7458340,$73120020,$67432910  2^(-2^9)
	DC.L	$5562684,$64626800,$34577256  2^(-2^10)
	DC.L	$3094346,$04738257,$82754802  2^(-2^11)
	DC.L	$9574977,$46095218,$53579467  2^(-2^12)
	DC.L	$9168019,$33777423,$58281071  2^(-2^13)
	DC.L	$8405257,$85778023,$37656567  2^(-2^14)
;
FP_EM	DC.W	-1,-1,-2,-3,-5,-10,-20
	DC.W	-39,-78,-155,-309,-617
	DC.W	-1234,-2467,-4933
;
FP_BP	DC.L	$2000000,0,0                  2^(2^0)
	DC.L	$4000000,0,0                  2^(2^1)
	DC.L	$1600000,0,0                  2^(2^2)
	DC.L	$2560000,0,0                  2^(2^3)
	DC.L	$6553600,0,0                  2^(2^4)
	DC.L	$4294967,$29600000,0          2^(2^5)
	DC.L	$1844674,$40737095,$51616000  2^(2^6)
	DC.L	$3402823,$66920938,$46346337  2^(2^7)
	DC.L	$1157920,$89237316,$19542357  2^(2^8)
	DC.L	$1340780,$79299425,$97099574  2^(2^9)
	DC.L	$1797693,$13486231,$59077293  2^(2^10)
	DC.L	$3231700,$60713110,$07300715  2^(2^11)
	DC.L	$1044388,$88141315,$25066918  2^(2^12)
	DC.L	$1090748,$13561941,$59294630  2^(2^13)
	DC.L	$1189731,$49535723,$17650800  2^(2^14)
;
FP_EP	DC.W	0,0,1,2,4,9,19,38,77,154
	DC.W	308,616,1233,2466,4932
;
; FP_SDX tests FP nos @ A0 & sets them to X type
;
; on entry D6.T = length of number (0-7 = S, 8-15 = D, 16 - 31 = X)
; on exit N is clear if no error, set otherwise
;
; Uses D3,D4,A0,A2
;
FP_SDX	MOVEA.L	A0,A2
	MOVEQ	#2,D3     count
FP_SDX1	TST.L	(A0)+
	DBNE	D3,FP_SDX1
	BEQ.S	FP_SDXE   good exit
;
; D6.BIT20 = 1 X else BIT19 = 1 D else S
;
	BTST	#20,D6
	BNE	FP_SDXX
	BTST	#19,D6
	BNE	FP_SDXD
	CMPI.W	#1,D3
	LEA	8(A2),A0  to start of number
	CMPI.L	#$80000000,(A0)
	BEQ	FP_SDMZ   OK (-0)
	BFEXTU	(A0){1:8},D3        D_EXP
	BEQ	FP_SDXW   ---->
	CMPI.B	#-1,D3
	BEQ	FP_SDIS   infinite
	ADDI.W	#$3FFF-$7F,D3       X_EXP
	BTST	#7,(A0)   sign
	BEQ.S	FP_SDX2   +
	BSET	#15,D3    set minus
FP_SDX2	MOVE.W	D3,(A2)+  sign/exponent
	CLR.W	(A2)+     zero word
	BFEXTU	(A0){9:23},D3       mantissa (fraction)
	BSET	#23,D3    j=1
	CLR.L	(A2)
	CLR.L	4(A2)
	BFINS	D3,(A2){0:24}       set mantissa
FP_SDXE	MOVE	#0,CCR    clear N
	RTS
;
FP_SDXW	MOVE	#8,CCR    set N
	RTS
;
FP_SDXD	LEA	4(A2),A0  to start of number
	CMPI.L	#$80000000,(A0)
	BNE.S	FP_SDXD2  not -0
	TST.L	4(A0)
	BEQ	FP_SDMZ   OK (-0)
FP_SDXD2	BFEXTU	(A0){1:11},D3       D_EXP
	BEQ.S	FP_SDXW   ---->
	CMPI.W	#$7FFF,D3
	BEQ.S	FP_SDID             infinite
	ADDI.L	#$3FFF-$3FF,D3      X_EXP
	BTST	#7,(A0)   sign
	BEQ.S	FP_SDXD1   +
	BSET	#15,D3    set minus
FP_SDXD1	MOVE.W	D3,(A2)+  set exponent
	CLR.W	(A2)+     zero word
	BFEXTU	(A0){12:31},D3      mantissa
	BFEXTU	4(A0){11:21},D4     (fraction)
	BSET	#31,D3    j=1
	MOVE.L	D3,(A2)+  1st part of mantissa
	CLR.L	(A2)
	BFINS	D4,(A2){0:21} 2nd part of mantissa
	BRA	FP_SDXE   good exit
;
FP_SDMZ	MOVE.L	#$80000000,(A2)+
FP_SDMZ1	CLR.L	(A2)+
	CLR.L	(A2)+
	BRA	FP_SDXE
;
FP_SDIS	CMPI.L	#$7F800000,(A0)
	BEQ	FP_SDIP   set plus infinity
	CMPI.L	#$FF800000,(A0)
	BEQ	FP_SDIM   set minus infinity
	BRA	FP_SDXW   ---->
;
FP_SDID	TST.L	4(A0)
	BNE	FP_SDXW   ---->
	CMPI.L	#$7FF00000,(A0)
	BEQ	FP_SDIP   set plus infinity
	CMPI.L	#$FFF00000,(A0)
	BEQ	FP_SDIM   set minus infinity
	BRA	FP_SDXW   ---->
;
FP_SDIX	TST.L	8(A0)
	BNE	FP_SDXW   ---->
	BFTST	4(A0){1:31}
	BNE	FP_SDXW   ---->
	BRA	FP_SDXE
;
FP_SDIP	MOVE.L	#$7FF00000,(A2)+
	BRA	FP_SDMZ1
;
FP_SDIM	MOVE.L	#$FFF00000,(A2)+
	BRA	FP_SDMZ1
;
FP_SDXX	MOVEA.L	A2,A0
	CMPI.L	#$80000000,(A0)
	BNE.S	FP_SDXX1  not -0
	TST.L	4(A0)
	BNE.S	FP_SDXX1  still not -0
	TST.L	8(A0)
	BEQ	FP_SDXE   OK (-0)
FP_SDXX1	BFEXTS	(A0){1:15},D3       X_EXP
	ADDQ.L	#1,D3
	BEQ	FP_SDIX   infinity
	BTST	#7,4(A0)  j
	BEQ	FP_SDXW   ---->
	BRA	FP_SDXE   good exit
;
; GLABA is a subroutine listing the
;       'PC' values in an EQU list
;       to O_BUF while 'compressing'
;
; On entry :-
;         A0 -> next entry in O_BUF
;         A1 -> LABEL -> EQU list
;         A2 -> end of BLSTCK list
;         A6 -> DATA SPACE
;         D2 = 0 if no PC yet: 1 otherwise
;         D3 = -1 if sign of EQU label is negative:plus otherwise
;         D4 = <id> of insert
;         D6 = value of the constant so far
;
; On exit :-
;         A0, A2 and D6 are updated
;         D0 = 0 if no error
;            = -1 if error
;            = -2 if EQU list contains labels of different sections
;
GLABA	MOVEM.L	D1-3/D7/A3-5,-(A7)
	CMPA.L	G_LIMIT(A6),A7
	BLT	QER35        ----> not enough space on stack
	MOVEQ	#0,D2
	MOVEA.L	VAL(A1),A3   -> EQU list
	MOVE.L	D6,D7        keep constant so far
	ADD.L	(A3)+,D6     add to constant
	ADDQ.L	#2,A3        go past S(PC)
	SWAP	D3           keep sign info @ top
GLA_P	MOVE.W	(A3)+,D3     + - or 0 (= end of EQU list)
	BEQ	GLA_END      end of EQU list
	MOVE.L	A0,A4
	MOVE.W	(A3)+,D1     EQU LABEL no
	BSR	LNPTR
	EXG	A0,A4
	MOVE.W	TYPE(A4),D0
	BTST	#4,D0
	BNE	GLA_ERJ ----> FP not allowed in EQ list
	BFTST	D0{22:2}
	BNE	GLA_ERJ ----> reg or reg list not allowed
	MOVE.W	D0,D1
	ANDI.W	#3,D1
	CMPI.B	#3,D1
	BEQ	GLA_ERJ	---->
	BTST	#13,D0
	BNE	GLA_ERJ2  XREF
	ANDI.W	#12,D0
	BEQ	GLA_ERJ   ---->
	CMPI.B	#4,D0
	BEQ	GLA_DEF   defined
	MOVE.W	-2(A3),D0
	MOVEA.L	BLSTCK(A6),A5
GLA_1	CMPA.L	A2,A5
	BGE.S	GLA_2     OK
	CMP.W	(A5)+,D0
	BNE.S	GLA_1
	BRA	GLA_ERJ   ---->
GLA_2	MOVE.W	D0,(A2)+  add to list
	MOVE.L	A1,-(A7)
	MOVEA.L	A4,A1
	BSR	GLABA
	MOVEA.L	(A7)+,A1
	ADDQ.L	#1,D0
	BEQ	GLA_ERJ  ---->	true error
	BPL	GLA_3
	OR.W	#2,D2		mark 'XREF'
GLA_3	SUBQ.L	#2,A2    -2(A2) -> this GLABA's label
	BRA	GLA_P
;
GLA_DEF	MOVE.L	VAL(A4),D0   value
	SUBQ.W	#1,D1     0 = N, 1 = PC
	BEQ.S	GLA_N
	CMP.W	(A4),D4   same <id>? ...
	BNE	GLA_ERJ2  ... no
;                          ____________________________
	LSL.L	#8,D0 | PC (3 bytes)| sign (1 byte)|
	TST.L	D3
	BPL.S	GLA_DEF1
	SUB.B	D3,D0
	BRA.S	GLA_DEF2
GLA_DEF1	ADD.B	D3,D0
GLA_DEF2	MOVE.L	D0,(A0)+  put in list
GLA_DEF3	SWAP	D2
	ADD.W	D3,D2
	SWAP	D2
	OR.W	#1,D2     mark PC been
	BRA	GLA_P
GLA_N	TST.W	D3
	BPL.S	GLA_PL
	NEG.L	D0
GLA_PL	ADD.L	D0,D6
	BRA	GLA_P
;
GLA_END	MOVEQ	#0,D0
	BCLR	#1,D2	XREF? . .
	BEQ	GLA_END6	. . no
	MOVEQ	#-2,D0	mark XREF
	MOVE.L	D2,D7
	SWAP	D7
	TST.W	D7	S(PC)
	BNE	GLA_END8	'PC'
;	MOVE.W	#$B009,TYPE(A1)	set type -> pseudo XREF/N
	TST.L	D2
	BEQ	GLA_END1
	BRA	GLA_END3		to mark PC been
;
GLA_END8	
;	MOVE.W	#$B00A,TYPE(A1)	set type -> pseudo XREF/PC
	BRA	GLA_END2
;
GLA_END6	TST.B	D2
	BNE.S	GLA_END2
	SUB.L	D6,D7
	NEG.L	D7
	MOVE.L	D7,VAL(A1)
	BFEXTS	-1(A2){6:2},D7   dummy strand = -1
	ADDQ.W	#1,D7               "         =  0
	BNE.S	GLA_END4         not dummy label
	CLR.W	TYPE(A1)
GLA_END4	ANDI.W	#$FFF2,TYPE(A1)     set type 5
	ORI.W	#5,TYPE(A1)
	BRA.S	GLA_END1
;
GLA_END2	CMPI.L	#$10001,D2      'PC' been & type 'PC'
	BEQ.S	GLA_END3
	CMPI.L	#1,D2           'PC' been & type 'N'
	BNE.S	GLA_ERJ   ---->
GLA_END3	OR.W	D2,6(A7)        mark 'PC' been
	SWAP	D2
	TST.L	D3
	BPL.S	GLA_END5
	SUB.W	D2,4(A7)
	BRA.S	GLA_END1
GLA_END5	ADD.W	D2,4(A7)        S(PCsign)
GLA_END1	TST.L	D0
GLA_END7	MOVEM.L	(A7)+,D1-3/D7/A3-5
	RTS
;
GLA_ERJ	MOVE.W	#7,TYPE(A1)  mark ERROR in LABEL
	MOVEQ	#-1,D0
	BRA.S	GLA_END7
GLA_ERJ2	OR.W	#2,D2	mark XREF been
	BTST	#0,D0
	BNE	GLA_P	'N'
	BRA	GLA_DEF3	'PC'
	BRA.S	GLA_END1
;
; COMY returns reductions (0, 2, 4 or 6) in D0
;      depending on whether D6.L is zero or
;      will fit into BYTE, WORD or LONG WORD
;      and according to the type (0 to 4).
;      D4.W contains type*16
;
COMY	MOVEM.L	D1-D3,-(A7)
	LEA	COM_DAT,A1          compression amounts per type
	MOVEM.L	(A1,D4.W),D0-3      go to D0 to D3
	TST.L	D6
	BEQ.S	COMY_0
	CMPI.L	#127,D6
	BGT.S	COMY_A
	CMPI.L	#-128,D6
	BGE.S	COMY_B
COMY_A	CMPI.L	#32767,D6
	BGT.S	COMY_L
	CMPI.L	#-32768,D6
	BGE.S	COMY_W
COMY_L	SUB.L	D3,D0
COMY_W	SUB.L	D2,D0
COMY_B	SUB.L	D1,D0
COMY_0	MOVEM.L	(A7)+,D1-3
	RTS
;
COM_DAT	DC.L	4,0,2,2
	DC.L	6,2,0,4
	DC.L	4,0,0,4
	DC.L	4,0,0,2
	DC.L	4,2,0,2
	DC.L	2,0,0,2
	DC.L	2,-2,2,2
;
; A few subroutines
;
; Entry A1 -> label entry
;       A4 -> insert
;       A0 -> XREF_LST
;       D2.L = constant
;
; At exit D5 = S(PC)
;
GLABB1	MOVE.W	SEC_NO(A6),D6	no of sections
	ADDQ.W	#3,D6
	LSR.W	#2,D6		no of longwords 
	LEA	SEC_EQLST(A6),A2
	BRA	GLABB_3
;
GLABB_2	CLR.L	(A2)+
GLABB_3	DBF	D6,GLABB_2
	MOVEA.L	BLSTCK(A6),A2
	MOVE.W	4(A4),(A2)+         label no
	MOVE.L	D2,D6     constant to D6
	LEA	8(A0),A0  point to start of {<op><id>}
GLABB	MOVEM.L	D1-3/D7/A3-5,-(A7)
	CMPA.L	G_LIMIT(A6),A7
	BLT	QER35     ---->     not enough space on stack
	MOVEA.L	VAL(A1),A3          -> EQU list
	TST.L	D5		1st entry to GLABB? . .
	BPL	GLB_P2		. . yes
	TST.L	D3		is EQU label +?
	BPL	GLB_P2		. . yes
	SUB.L	(A3)+,D6
	BRA	GLB_P3
GLB_P2	ADD.L	(A3)+,D6  S(constant)
GLB_P3	ADDQ.L	#2,A3     pass S(PC)
GLB_P	MOVE.W	(A3)+,D3  sign
	BEQ	GLB_END   finished
	TST.L	D5	first time? . .
	BPL	GLB_P1	. . yes
	TST.L	D3	is EQU label +? . .
	BPL	GLB_P1	. . yes
	NEG.W	D3	set opposite sign
GLB_P1	MOVEA.L	A0,A4
	MOVE.W	(A3)+,D1  label no
	BSR	LNPTR
	EXG	A0,A4
	MOVE.W	TYPE(A4),D0
	MOVE.W	D0,D1
	ANDI.B	#3,D1
	CMPI.B	#3,D1
	BEQ	GLB_ERJ	---->
	BTST	#4,D0
	BNE	GLB_ERJ   ----> FP  or string
	BFTST	D0{22:2}
	BNE	GLB_ERJ   ----> reg or reg list not allowed
	BTST	#3,D0
	BNE	GLB_3	EQU list
	BTST	#13,D0    XREF? ...
	BNE	GLB_XR    ... yes
	ANDI.B	#12,D0
	BEQ	GLB_ERJ   ---->
	BRA	GLB_DEF
;
GLB_3	MOVE.W	-2(A3),D0 label no
	MOVEA.L	BLSTCK(A6),A5
GLB_1	CMPA.L	A2,A5
	BGE.S	GLB_2     OK (not in list)
	CMP.W	(A5)+,D0  is it in ? ...
	BNE.S	GLB_1     ... not so far
	BRA	GLB_ERJ   ---->
GLB_2	MOVE.W	D0,(A2)+  set THIS label in list
	MOVE.L	A1,-(A7)
	MOVEA.L	A4,A1
	SWAP	D3	set D3.top = sign of EQU label
	BSET	#31,D5	mark subsequent entries to GLABB
	BSR	GLABB
	MOVEA.L	(A7)+,A1
	BMI	GLB_ERJ   ---->
	SWAP	D3	reset the previous D3.top
	BRA	GLB_P
GLB_DEF	MOVE.L	VAL(A4),D0          value
	SUBQ.B	#1,D1     0=N 1=PC
	BEQ.S	GLB_N     N
	MOVE.W	(A4),D1             section id for PC label
	TST.W	D3
	BPL.S	GLB_DEF1
	SUBQ.W	#1,D5
	SUBI.B	#1,SEC_EQLST(A6,D1.W)
	BRA.S	GLB_N
GLB_DEF1	ADDI.B	#1,SEC_EQLST(A6,D1.W)
	ADDQ.W	#1,D5
GLB_N	TST.W	D3
	BPL.S	GLB_N1
	NEG.L	D0
GLB_N1	ADD.L	D0,D6     const
	BRA	GLB_P
;
GLB_XR	PEA	XREF_LST(A6)
	SUBA.L	XREF_LST(A6),A0	space so far . .
	PEA	3(A0)		. . and 3 more
	PEA	2		relocation wanted
	BSR	GSP	check that the space exists
	LEA	12(A7),A7		tidy stack
	ADDA.L	XREF_LST(A6),A0	reset A0
	MOVEQ	#0,D1     prepare for 'N'
	BTST	#1,D0
	BEQ.S	GLB_XR3   N
	MOVEQ	#1,D1
GLB_XR3	TST.W	D3
	BPL.S	GLB_XR1
	MOVE.B	#"-",(A0)+
	SUB.W	D1,D5
	BRA.S	GBL_XR2
GLB_XR1	MOVE.B	#"+",(A0)+
	ADD.W	D1,D5
GBL_XR2	MOVE.W	VAL+2(A4),(A0)+     XREF id
	BRA	GLB_P
;
GLB_ERJ	MOVEQ	#-1,D0
GLB_END	MOVEM.L	(A7)+,D1-3/D7/A3-5
	RTS
;
; On entry:
; A0 -> next space in XREF_LST
; D6 = constant
;
; Uses D0-D2 A0-A1
;
AGLB	MOVEM.L	A2-3/D3,-(A7)
	MOVEQ	#0,D2		set to 0 just to get ..
	BSR	INS_FXL		. . A2 -> XREF_LST entry
	MOVE.L	D6,3(A2)  sets constant
	TST.B	REL_SWTCH(A6)	has ORG been? . .
	BPL	AGLB5		. . no
	BCLR	#6,7(A2)		stop relocation if ORG
AGLB5	MOVE.W	SEC_NO(A6),D2	no of sections
	LEA	SEC_EQLST(A6,D2.W),A1
	LEA	2(A0),A3
	SUBA.L	XREF_LST(A6),A3	total length needed
	BSR	AGSP		see that it is there
	BRA	AGLB6
;
AGLB1	MOVE.B	-(A1),D1  s
	EXT.W	D1
	BEQ	AGLB6
	BMI	AGLB2
	MOVEQ	#"+",D0
	BRA	AGLB7
;
AGLB2	MOVEQ	#'-',D0
	NEG.W	D1
AGLB7	CMPI.B	#2,CO_SE(A6,D2.W)
	BEQ	AGLB6	no <op><id> if ORG
	MOVEQ	#-1,D3
	SUB.W	D2,D3	<id>
	ADDA.W	D1,A3		add 3*D1.W . .
	LEA	(A3,D1.W*2),A3	. . bytes to A3 . .
	BSR	AGSP		. . and see space is there
	BRA.S	AGLB3
;
AGLB4	MOVE.B	D0,(A0)+		<op>
	MOVE.W	D3,(A0)+		<id>
AGLB3	DBF	D1,AGLB4
AGLB6	DBF	D2,AGLB1
	MOVE.W	#$FB00,(A0)
	SUBA.L	A2,A0
	MOVE.L	A0,D0
	MOVE.B	D0,(A2)
	MOVEM.L	(A7)+,D3/A2-3
	RTS
;
AGSP	SUBA.L	XREF_LST(A6),A2
	SUBA.L	XREF_LST(A6),A0
	PEA	XREF_LST(A6)	XREF_LST(A6) address
	PEA	(A3)		space needed
	PEA	2		relocation needed
	BSR	GSP
	LEA	12(A7),A7		restore stack
	ADDA.L	XREF_LST(A6),A2	replace A2 . .
	ADDA.L	XREF_LST(A6),A0	. . and A0
	RTS
;
AGLB_ER	MOVEM.L	(A7)+,D3/A2-3
	ADDQ.L	#4,A7
	BRA	INS_ER84	---->
;
; Sets PC_TOT  = BIN_POS + amount in O_BUF
;      PC_INST = A5
;
; Uses A0
;
SET_PC	MOVE.L	D1,-(A7)
	LEA	O_BUF(A6),A0
	MOVE.L	(A0)+,D1
	SUB.L	A0,D1     amount in O_BUF
	ADD.L	BIN_OUT(A6),D1
	MOVE.L	D1,PC_TOT(A6)
	MOVE.L	A5,PC_INST(A6)
	MOVE.L	([BINS,A6]),EA_INSMK(A6)      keep INS position
	MOVE.L	BINS(A6),EA_INSMK1(A6)               "
	MOVE.L	(A7)+,D1
	RTS
;
; NLAB_NO sets LABEL number in D1.W given
; a name pointed to by A2
; D0=0 if OK, -1 if no name list chunk else is
;      the address of the name list chunk
; A0 -> Info if found
;
; Uses D0 & D1 only
;
NSECT_NO	MOVEQ	#3,D0
	BRA.S	NLAB_L0
NMAC_NO	MOVEQ	#0,D0
	BRA.S	NLAB_L0
NLAB_NO	MOVEQ	#6,D0
NLAB_L0	MOVEM.L	D2-5/A1/A3-5,-(A7)
	MOVE.L	D0,D5
	MOVE.W	(A2),D0   count
	MOVE.W	D0,D3
	LEA	1(A2),A0
	MOVEQ	#0,D1
NLAB_L2	ADD.B	(A0)+,D1  hash total
	DBF	D3,NLAB_L2
	DIVU.W	#3,D1
	SWAP	D1
	MOVE.W	D1,D2
	ADD.W	D5,D2
	MOVE.L	MAC_LST(A6,D2.W*4),D2     address of 1st strand
	BEQ	NLAB_ER1  ----> no name list
	MOVEA.L	D2,A0
	MOVEQ	#0,D2     allow byte_puts to set word
NLAB_L3	MOVEA.L	A0,A5
	SUBQ.W	#4,D1     retard count
	MOVEA.L	(A0)+,A1  1st free space in chunk
	MOVE.L	(A0)+,D4  address of next chunk (or 0)
NLAB_L4	ADDQ.W	#4,D1     advance count
	CMPA.L	A1,A0     chunk ended? ....
	BGE	NLAB_L5   .... yes
	MOVE.B	(A0)+,D2  name length
	LEA	(A0,D2.W),A4        -> next name
	CMP.W	D0,D2     are counts equal? ....
	BNE	NLAB_L6   .... no
	LEA	2(A2),A3  -> start of name
	BRA.S	NLAB_L7
NLAB_L8	CMPM.B	(A3)+,(A0)+         compare till not equal
NLAB_L7	DBNE	D2,NLAB_L8
	BNE	NLAB_L6   not found
	SWAP	D1
	MOVE.W	D5,D1
	BSR	LNPTR3    set  A0 -> info
	MOVEQ	#0,D0
NLAB_EX	MOVEM.L	(A7)+,D2-5/A1/A3-5
	RTS
;
NLAB_L6	MOVEA.L	A4,A0     -> next name
	BRA	NLAB_L4
;
NLAB_L5	TST.L	D4        more chunks? ....
	BEQ	NLAB_ER   .... no
	MOVEA.L	D4,A0     -> next chunk
	BRA	NLAB_L3
;
NLAB_ER	MOVE.L	A5,D0     set address of chunk
	BRA	NLAB_EX
;
NLAB_ER1	MOVEQ	#-1,D0
	BRA	NLAB_EX
;
; LNPTR, MNPTR and SNPTR set the address of the 1st chunk
;  of information in A0 for LABELS, MACROS and SECTIONS.
;
; On entry D1.W = the number of the item.
; On exit condition Z is set if there is no 1st chunk.
;                   N is set if there is no chunk for this label.
; The top word of D1 is used
;
MNPTR	SWAP	D1
	MOVE.W	#0,D1
	BRA.S	LNPTR3
SNPTR	SWAP	D1
	MOVE.W	#3,D1
	BRA.S	LNPTR3
LNPTR	SWAP	D1
	MOVE.W	#6,D1
LNPTR3	SWAP	D1
LNPTR5	MOVE.L	D0,-(A7)
	MOVE.W	D1,D0
	ANDI.W	#3,D0     strand
	SWAP	D1
	ADD.W	D1,D0
	SWAP	D1
	MOVEA.L	MINN(A6,D0.W*4),A0  address of 1st chunk (or 0)
	CMPA.L	#0,A0
	BEQ.S	LNPTR4              no chunk
	BFEXTU	D1{17:7},D0         no of chunks - 1
	BRA.S	LNPTR1
LNPTR2	TST.L	(A0)                next chunk? ...
	BEQ	LNPTR7              ... no
	MOVEA.L	(A0),A0             -> next chunk
LNPTR1	DBF	D0,LNPTR2
	BFEXTU	D1{24:6},D0         position within chunk
	LEA	8(A0,D0.W*8),A0     -> item itself
	MOVE	#0,CCR              set non-zero
LNPTR4	MOVEM.L	(A7)+,D0
	RTS
LNPTR7	MOVE	#8,CCR              set 'N' -> CCR
	BRA.S	LNPTR4
;
; CHK_L returns 'EQ' if D1.W does not point to a label - else 'NE'
; On exit A0 -> LINN
;
CHK_L	MOVE.L	D0,-(A7)
	BSR	LNPTR
	BEQ	CHK_L1
	BFEXTU	D1{24:6},D0
	LSL.W	#3,D0     bytes offset
	CMPI.W	#LLEN-8,D0
	BEQ	CHK_L1
	CMPI.W	#-2,(A0)
CHK_L1	MOVEM.L	(A7)+,D0
	RTS
;
; NNEW_LAB, NNEW_MAC and NNEW_SEC puts a new name in the name list
;   and sets A0 -> the info item
;
; On entry:
;  D0.L = address of start of name chunk (-1 if none)
;  D1.W = label number
;  A0 -> next name entry
;  A2 -> name
;
NNEW_MAC	SWAP	D1
	MOVE.W	#0,D1
	BRA.S	NN_LAB0
NNEW_SEC	SWAP	D1
	MOVE.W	#3,D1
	BRA.S	NN_LAB0
NNEW_LAB	SWAP	D1
	MOVE.W	#6,D1
NN_LAB0	SWAP	D1
	MOVEM.L	D1-3/A1-5,-(A7)
	MOVEA.L	D0,A4
	MOVEA.L	A2,A5
	TST.L	D0
	BPL.S	NN_LAB6   chunk exists
	BSR	NN_LG     A0 -> new chunk ....
	BNE	NN_LAB_ER .... unless error
	MOVE.W	D1,D0
	ANDI.W	#3,D0     strand number
	SWAP	D1
	ADD.W	D1,D0
	SWAP	D1
	MOVE.L	A0,MAC_LST(A6,D0.W*4)   set 1st ptr to name list
	MOVE.L	A0,D0
	MOVEA.L	A0,A4
	LEA	8(A0),A0  -> 1st name space
	MOVE.L	A0,(A4)
NN_LAB6	ADDI.L	#CHLEN-1,D0
	SUB.L	A0,D0     available space - 1
	CMP.W	(A5),D0   will it fit? ....
	BGE.S	NN_LAB1   .... yes
	BSR	NN_LG
	BNE	NN_LAB_ER
	MOVE.L	A0,4(A4)  set new address in old chunk
	MOVEA.L	A0,A4
	LEA	8(A0),A0  point to 1st free space
NN_LAB1	MOVE.W	(A5),D0   name length
	ADDQ.L	#1,A5     prepare for byte length
NN_LAB2	MOVE.B	(A5)+,(A0)+
	DBF	D0,NN_LAB2
	MOVE.L	A0,(A4)   set new free position
	MOVE.L	(A7),D1   retrieve label no
	BSR	LNPTR5    try and set A0 -> info
	BEQ	NN_LAB8   no 1st chunk
	BPL	NN_LAB5   chunk exists
;
; No chunk for this label
;
	MOVEA.L	A0,A5     set start address of last chunk
	BSR	NN_LH     try and get another one ...
	BNE	NN_LAB_ER ... oops!
	MOVE.L	A0,(A5)   set new address in old chunk
NN_LAB9	MOVEA.L	A0,A5     and set start of new chunk -> A5
	LEA	8(A0),A0  -> 1st item
	BRA	NN_LAB3
NN_LAB8	BSR	NN_LH     try again to set A0 -> info
	BNE	NN_LAB_ER ----> Failure!
	MOVE.W	D1,D0
	ANDI.W	#3,D0     strand number
	SWAP	D1
	ADD.W	D1,D0     adjust for MAC, SEC or LAB
	SWAP	D1
	MOVE.L	A0,MINN(A6,D0.W*4)  set 1st address to inf list
	BRA	NN_LAB9
NN_LAB5	BFEXTU	D1{24:6},D0         chunk offset
	NEG.L	D0
	LEA	-8(A0,D0.L*8),A5      -> start of chunk
NN_LAB3	CLR.L	(A0)      clear all
	CLR.L	4(A0)     label info
	MOVE.L	#LLEN-8,D0
	ADD.L	A5,D0
	SUB.L	A0,D0
	BLE.S	NN_LAB4   no room for another item
	MOVE.W	#-2,8(A0) mark end of items
NN_LAB4	MOVEM.L	(A7)+,D1-3/A1-5
	RTS
;
NN_LAB_ER	LEA	36(A7),A7 restore stack
	BRA	PR_E16    ---->
;
; SR  to get chunk  _LH for info: _LG for name
; Entry NN_LG2 needs D1.L = bytes to ALLOC
; On exit D0 = 0 OK or <>0 error (CCR is set)
;         A0 -> new area (1st 8 bytes cleared)
;   No other regs used
;
NN_LG2	MOVE.L	D1,D0
	BRA	NN_LG1
NN_LH	MOVE.L	#LLEN,D0
	BRA.S	NN_LG1
NN_LG	MOVE.L	#CHLEN,D0
NN_LG1	MOVEM.L	D1-4/A1-5,-(A7)
	MOVE.L	D0,D1
	MOVE.L	D0,D4
	BSR	ALC
	BNE	NN_LG3
NN_LG8	MOVEM.L	(A7)+,D1-4/A1-5
	RTS
;
NN_LG3	MOVEQ	#MT_FREE,D0
	TRAP	#1
	CMPI.L	#ALC_MIN,D1
	BLT	NN_LG8    ----> too small to ALLOC
	LSR.L	#5,D1     best min to ALLOC
	CMPI.L	#ALC_MAX,D1
	BLE	NN_LG5
	MOVE.L	#ALC_MAX,D1
NN_LG5	MOVEQ	#MT_ALCHP,D0
	TRAP	#1
	TST.L	D0
	BNE	NN_LG8    ---->
	MOVEA.L	A0,A4
	LEA	HEAPAD(A6),A1
	MOVEA.W	MM_LNKFR,A2
	JSR	(A2)
	MOVEQ	#8,D1
	BSR	ALC
	BNE	NN_LG8    ---->
	LEA	X_ALLOC1(A6),A5     1st link
	BRA	NN_LG6
NN_LG7	MOVEA.L	D0,A5
NN_LG6	MOVE.L	(A5),D0   next address
	BNE	NN_LG7
	MOVE.L	A0,(A5)   set new address in old link
	MOVE.L	A4,4(A0)  set ALCHP'd address in chain
	MOVE.L	D4,D1
	BSR	ALC
	BRA	NN_LG8
;
ALC	MOVEA.W	MM_ALLOC,A2
	LEA	HEAPAD(A6),A0
	JSR	(A2)
	TST.L	D0
	BNE	ALC_1
	CLR.L	(A0)
	CLR.L	4(A0)
ALC_1	RTS
;
; To release space ALCHP'd
;
REL_SPC	MOVE.L	X_ALLOC1(A6),D0     start of chain
	BEQ	REL_SPC1
REL_SPC2	MOVEA.L	D0,A4
	MOVEA.L	D0,A0
	MOVEQ	#MT_RECHP,D0
	TRAP	#1
	MOVE.L	(A4),D0   next link
	BNE	REL_SPC2
	CLR.L	X_ALLOC1(A6)
REL_SPC1	RTS
;
; Sets D0.B = 0 to 35 for 0 - 9, a - z, A - Z or -1
; No other reg used
;
MAC_PAR	SUBI.B	#'0',D0
	BLT	MAC_PAR1  ---->
	CMPI.B	#9,D0
	BLE	MAC_PAR2
	ADDI.B	#'0',D0
	BCLR	#5,D0     -> upper case
	SUBI.B	#$37,D0   -> 10 to 35
	CMPI.B	#10,D0
	BLT	MAC_PAR1  ---->
	CMPI.B	#35,D0
	BGT	MAC_PAR1  ---->
MAC_PAR2	RTS
MAC_PAR1	MOVE.B	#-1,D0
	RTS
;
; SDUM sets up a dummy label in strand 4
;
; On exit A0 -> label info
;         D3.W = label number
;         Condition code N is set for error
;
; Uses A4,D1
;
SDUM	MOVEM.L	D0/D2/D4,-(A7)
	MOVE.W	#-$101,D3
	MOVE.L	LINN+12(A6),D4      start of dummy LINN
	BNE.S	SDUM_1    chunk exists
	LEA	LINN+LLEN+12(A6),A4 address will go to -LLEN(A4)
	BSR	SDUM_6    start new strand
	MOVE.W	#-2,(A0)  set 1st item as last
SDUM_1	ADDI.W	#$100,D3   count of chunks
	MOVEA.L	D4,A0
	MOVE.L	(A0),D4   address of next chunk? ....
	BNE.S	SDUM_1    .... yes. Get it
	MOVE.L	A0,D4
	LEA	LLEN(A0),A4         set A4 -> end of chunk
SDUM_2	ADDQ.W	#4,D3     count item inside chunk
	ADDQ.L	#8,D4     next item
	CMPA.L	D4,A4     end of chunk? ....
	BEQ.S	SDUM_3    .... yes
	CMPI.W	#-2,(D4.L)          1st free space? ....
	BNE.S	SDUM_2              .... not yet
	MOVEA.L	D4,A0     -> item (D4.L > 0)
	ADDQ.L	#8,D4     sets CON CODE > 0
	CMP.L	A4,D4
	BGE.S	SDUM_5
SDUM_8	MOVE.W	#-2,8(A0) mark end of list
SDUM_5	CLR.W	(A0)      'section' -> 0
	MOVE	#4,CCR    mark OK
SDUM_4	MOVEM.L	(A7)+,D0/D2/D4
	RTS
;
SDUM_3	PEA	SDUM_8
SDUM_6	MOVEM.L	D3/A1-3,-(A7)
	MOVE.L	#LLEN,D1
	LEA	HEAPAD(A6),A0
	MOVEA.W	MM_ALLOC,A2
	JSR	(A2)
	MOVEM.L	(A7)+,D3/A1-3
	TST.L	D0
	BNE.S	SDUM_7    no room
	MOVE.L	A0,-LLEN(A4)        set new address in old chunk
	MOVE.L	A0,D4
	CLR.L	(A0)                mark 'last chunk'
	LEA	8(A0),A0            -> 1st item
	RTS
SDUM_7	ADDQ.L	#4,A7
	BRA	SDUM_4
;
; On entry D3.W = label number
;
; Entry points are GNL for labels, GNM for macros & GNS
;                  for sections
; On good exit  A2 -> label name
;               A0 -> start of chunk
;               cc set for 0
;
; On bad exit   A2 is indeterminate
;               A0 = 0
;               cc set for -1
;
GNL	SWAP	D3
	MOVE.W	#6,D3
	BRA.S	GNL_5
GNM	SWAP	D3
	CLR.W	D3
	BRA.S	GNL_5
GNS	SWAP	D3
	MOVE.W	#3,D3
GNL_5	SWAP	D3
	MOVEM.L	D1-3/A3,-(A7)
	MOVE.W	D3,D1
	ANDI.W	#3,D1     strand no
	SWAP	D3
	ADD.W	D3,D1
	SWAP	D3
	MOVEA.L	MAC_LST(A6,D1.W*4),A2         1st name chunk
	MOVE.L	MINN(A6,D1.W*4),D2            1st info chunk
	BEQ	GNL_BEX   chunk dosen't exist
	BFEXTU	D3{17:7},D1         no of chunks-1
	BEQ.S	GNL_8               only one
	BRA.S	GNL_6
GNL_7	MOVE.L	(D2.L),D2           -> next chunnk
GNL_6	DBEQ	D1,GNL_7
	BEQ	GNL_BEX             no chunk
GNL_8	BFEXTU	D3{24:6},D1         position in chunk - 8
	MOVEA.L	D2,A0               -> start of chunk
	ADDI.L	#LLEN,D2            -> end of chunk
	LEA	8(A0,D1.W*8),A0     -> item
	CMP.L	A0,D2
	BLE	GNL_BEX             no item
	CMPI.W	#-2,(A0)            end marker? ...
	BEQ	GNL_BEX             ... yes
	BFEXTU	D3{30:2},D2         no of strand
	LSR.W	#2,D3               count within strand
	BRA.S	GNL_1
GNL_4	MOVE.B	(A2),D2   length to D2.W (sic!)
	LEA	1(A2,D2.W),A2       -> next name
	CMPA.L	A3,A2     chunk ended? ....
	BLT.S	GNL_2     .... no
	TST.L	D1
	BEQ	QER28     ----> it shouldn't happen!!
	MOVEA.L	D1,A2
GNL_1	MOVEA.L	A2,A0
	MOVEA.L	(A2)+,A3  1st free section
	MOVE.L	(A2)+,D1  -> next chunk
GNL_2	DBF	D3,GNL_4
	MOVEQ	#0,D1     set condition codes (cc)
GNL_9	MOVEM.L	(A7)+,D1-3/A3
	RTS
;
GNL_BEX	SUBA.L	A0,A0
	MOVEQ	#-1,D1    set cc
	BRA.S	GNL_9
;
; SR for reading chunks from EQU_SYM _SN for name & _SL for info
;
; On entry D3.W = -1
;          D2.W = count of bytes
;          A0 = chan ID
;          A1 -> next place to receive information
;
EQU_SN	MOVE.L	#CHLEN,D6 length of chunk
	MOVEQ	#4,D7
	BRA.S	EQU_S
EQU_SL	MOVE.L	#LLEN,D6
	MOVEQ	#0,D7
EQU_S	MOVE.L	A1,D5     keep start of area
	MOVEQ	#IO_FSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QER3      ---->
	MOVE.W	D2,D0
	DIVU.W	D6,D0
	SWAP	D0
	TST.W	D0
	BNE	QER3      ---->
	SWAP	D0
	MOVEA.L	D5,A2
	SUBA.L	D6,A2
	BRA.S	EQU_S1
EQU_S2	LEA	(A2,D6.L),A2        to next chunk
	TST.W	D7
	BEQ.S	EQU_S3    info not name
	ADD.L	D5,(A2)   rel -> absolute
EQU_S3	ADD.L	D6,D5
	MOVE.L	D5,(A2,D7.W)
EQU_S1	DBF	D0,EQU_S2
	CLR.L	(A2,D7.W) no next chunk
	CMPI.L	#$10000,D4
	BGE.S	EQU_S4    nothing to do
	MOVEQ	#2,D0
	SUB.W	D4,D0		set to strands 0, 1, 2
	MOVEM.L	D0/A0/A2,-(A7)
	LEA	$40+BUF(A6),A2      -> 'odd' label name
	MOVE.B	D0,$44+BUF(A6)
	BSR	NLAB_NO
	MOVEM.L	(A7)+,D0/A0/A2
	BEQ	QER3      ---->     we should not find the name!
	MOVE.W	D1,SL1(A6,D0.W*2)   set SLi
EQU_S4	RTS
;
; SXX writes SECTIONs or XREF/XDEF directives to _o
;
; On entry D2.W =2 and D2.L is neg for XDEF/XREF
;
SXX	TST.L	D2
	BMI.S	SECT_6    XREF/XDEF
	MOVEA.L	SEC_LST(A6,D2.W*4),A3
	BRA.S	SECT_7
SECT_6	MOVEA.L	LAB_LST(A6,D2.W*4),A3
SECT_7	CMPA.L	#0,A3     is there a strand? ...
	BEQ	SECT_2    ... no
	MOVE.W	D2,D1
SECT_3	MOVEA.L	(A3)+,A2  to end of last name
	MOVE.L	(A3)+,D4  address of next chunk
SECT_4	CMPA.L	A2,A3     more items? ...
	BGE	SECT_5    ... no
	TST.L	D2
	BMI	SECT_9    XREF/XDEF
	LEA	6+BUF(A6),A1
	BSR	XSYMB3
	BSR	SNPTR     A0 -> info
	ADDQ.W	#4,D1     advance symbol number
***********************************
* Try cutting out 'ORG;n' entries *
	CMPI.W	#2,TYPE(A0)   *
	BEQ	SECT_4        *
***********************************
	MOVEQ	#-1,D0
	SUB.W	(A0),D0   section no (-1,-2 ..)
	MOVE.W	D0,4+BUF(A6)
SECT_8	ADDQ.W	#5,D3     length
	MOVE.W	D3,BUF(A6)
	LEA	1+BUF(A6),A1
SECT_13	BSR	PXPUT
	BRA	SECT_4
SECT_5	TST.L	D4        more chunks? ...
	BEQ.S	SECT_2    ... no
	MOVEA.L	D4,A3
	BRA	SECT_3
SECT_2	DBF	D2,SXX
	RTS
;
SECT_9	BSR	LNPTR
	ADDQ.W	#4,D1
	BFEXTU	TYPE(A0){2:2},D0
	BEQ	SECT_10   not XREF/XDEF
	CMPI.B	#1,D0
	BEQ.S	SECT_11   XDEF
	CMPI.B	#3,D0
	BEQ	SECT_10	pseudo XREF
	MOVE.W	VAL+2(A0),4+BUF(A6) <id>
	LEA	6+BUF(A6),A1
	BSR	XSYMB3
	BRA	SECT_8
SECT_11	BFEXTU	TYPE(A0){14:2},D0
	CMPI.B	#3,D0     error? . . .
	BNE	SECT_14   . . . no
	MOVEQ	#67,D0    set error no
	BRA	INS_WARN  put it in and exit
SECT_14	LEA	36+BUF(A6),A1
	BSR	XSYMB3
	ADDI.W	#9,D3     length
	MOVE.W	D3,32+BUF(A6)
	MOVE.L	VAL(A0),(A1)+       value of label
	MOVEQ	#0,D0     prepare for N type
	CMPI.B	#6,TYPE+1(A0)
	BNE.S	SECT_12   not PC
	MOVE.W	(A0),D0	section <id>
	CMPI.B	#2,CO_SE(A6,D0.W)	is it ORG? . .
	BNE	SECT_15		. . no
	MOVEQ	#0,D0
	BRA	SECT_12
SECT_15	ADDQ.W	#1,D0
	NEG.W	D0
SECT_12	MOVE.W	D0,(A1)
	LEA	33+BUF(A6),A1
	BRA	SECT_13
SECT_10	MOVE.B	(A3)+,D0
	EXT.W	D0
	LEA	(A3,D0.W),A3        to next name
	BRA	SECT_4
;
SET_MNE	LEA	1+PROMPT(A6),A3
SET_MNE1	CLR.B	MOD_NME(A6)         prepare for byte length
	LEA	1+MOD_NME(A6),A1
XSYMB3	MOVE.B	(A3),D0
	EXT.W	D0
	MOVE.W	D0,D3
XSYMB2	MOVE.B	(A3)+,(A1)+
	DBF	D0,XSYMB2
	RTS
;
; MAC_STRG reads in parameters for MACROs
;
; As for STRG but with TAB, SPACE, ENTER, COMMA as terminators
; and distinguishing cases.
; If the parameter starts with '<' all characters are copied
; exactly as they are until a final, single '>'.
; If the string is null (and no '<>') D2 is set to -2.
; On an error D2.W=-1. In all other cases D2.W is positive.
;
; Entry:  D2.W must contain the maximum size of this parameter
;
MAC_STRG	LEA	BUF+2(A6),A2	
	MOVE.W	D2,BUF(A6)	keep buffer size
	MOVEQ	#0,D0     set bit 31 -> 0
	MOVE.B	(A1)+,D0
	CMPI.B	#'<',D0
	BEQ	MST_L4
MST_L	TST.L	D0
	BMI	MST_L5
	CMPI.B	#9,D0     TAB
	BEQ	MAC_STEND
	CMPI.B	#10,D0    ENTER
	BEQ	MAC_STEND
	CMPI.B	#32,D0    SPACE
	BEQ	MAC_STEND
	CMPI.B	#",",D0
	BEQ	MAC_STEND
MST_L3	MOVE.B	D0,(A2)+
	MOVE.B	(A1)+,D0
	DBF	D2,MST_L
	TST.W	D2
	BRA.S	MAC_STEX ---->
MAC_STEND	NEG.W	D2
	ADD.W	BUF(A6),D2	buffer size
	BEQ	MST_L6    deal with zero length
MST_L7	LEA	BUF(A6),A2
	MOVE.W	D2,(A2)
MAC_STEX	RTS
;
MST_L4	MOVEQ	#-1,D0
	MOVE.B	(A1)+,D0
MST_L5	CMPI.B	#'>',D0
	BNE	MST_L3
	MOVE.B	(A1)+,D0
	CMPI.B	#'>',D0
	BEQ	MST_L3    ignore 1st
	BRA	MAC_STEND
;
MST_L6	TST.L	D0
	BMI	MST_L7    <> case
	MOVEQ	#-2,D2    another line?
	BRA	MAC_STEX
;
; PUT_STRG sets a string from BUF to an ALLOC'd
; area and enters label info.
;
; At entry A2 -> label INF
;
PUT_STRG	MOVE.W	#$35,TYPE(A2)   set 'string' marker
	MOVEQ	#2,D1
	ADD.W	BUF(A6),D1          count
	BSR	NN_LG2              A0 -> space
	MOVE.L	A0,VAL(A2)          -> string
	LEA	2+BUF(A6),A3        string itself
	MOVE.W	BUF(A6),D1	replace true length
	MOVE.W	D1,(A0)+		length
	BRA	PUT_STRG1
PUT_STRG2	MOVE.B	(A3)+,(A0)+
PUT_STRG1	DBF	D1,PUT_STRG2
	RTS
;
; FETCHB fetches D2.W bytes from CH_OUT via BIN_BUF
;        and puts them to A1 (which is updated)
;
; BIN_BUF ______________________________________________________
;        |    pointer (L)    | bytes left (W)|                  |
;
FETCHB	MOVEA.L	BIN_BUF(A6),A3
FETCHB_1	MOVE.W	4(A3),D3  bytes left
	MOVEA.L	(A3),A3   pointer
	CMP.W	D3,D2     all in buffer? ...
	BGT	FETCHB_2  ... no
	SUB.W	D2,([BIN_BUF,A6],4) reset bytes left
	BRA.S	FETCHB_4
FETCHB_3	MOVE.B	(A3)+,(A1)+
FETCHB_4	DBF	D2,FETCHB_3
	MOVE.L	A3,([BIN_BUF,A6])   reset pointer
	RTS
;
FETCHB_2	SUB.W	D3,D2     bytes left (>0)
	BRA.S	FETCHB_5
FETCHB_6	MOVE.B	(A3)+,(A1)+
FETCHB_5	DBF	D3,FETCHB_6         now D3.W = -1
	MOVEM.L	D2/A1,-(A7)
	MOVEA.L	CH_OUT(A6),A0
	MOVEA.L	BIN_BUF(A6),A1
	LEA	6(A1),A1  set to start of data
	MOVE.W	#B_BUFSZE,D2
	MOVEQ	#IO_FSTRG,D0
	TRAP	#3
	MOVEM.L	(A7)+,D2/A1
	TST.L	D0
	BEQ	FETCHB_7  OK
	CMPI.B	#-10,D0
	BNE	QER1      ---->
FETCHB_7	MOVEA.L	BIN_BUF(A6),A3
	MOVE.W	D1,4(A3)  set no of bytes left
	BEQ	QER1      ---->     should be some!!
	LEA	6(A3),A0
	MOVE.L	A0,(A3)   set pointer
	BRA	FETCHB_1
;
; To set PC_TH(A6) & PC_PR(A6) the current and previous PC_LST items
; uses D0, D1 & A0
;
ST_LNO	MOVE.L	PC_TH(A6),D0
	MOVE.L	D0,PC_PR(A6)        set the previous value
	BMI	ST_LNO1             no chunks
	ADDQ.L	#6,PC_TH(A6)        step to next PC entry
	SUBI.L	#PC_SZE-13,D0
	SUB.L	PC_CS(A6),D0        is there enough space? . .
	BPL	ST_NLO2             . . no
	RTS
ST_NLO2	SUBQ.L	#6,D0
	BMI	ST_NLO3             space for 1
	PEA	ST_LNOB             arrange for next chunk
ST_NLO3	MOVE.L	([PC_CS,A6]),D0
	BEQ	ST_LNO4             no next chunk
	MOVEA.L	D0,A0               (in case we go to ST_LNOB)
	RTS
ST_LNO4	BSR	ST_LNOA             get a chunk
	BRA	ST_LNOC             end
;
ST_LNO1	BSR	ST_LNOA             get a chunk
	MOVE.L	A0,PC_CS1(A6)       set start address
	BRA	ST_LNOB
;
ST_LNOA	MOVE.L	#PC_SZE,D1
	BSR	NN_LG2
	BNE	QER4      ---->
	MOVE.L	A0,D0
	LSR.L	#2,D1
	BRA	ST_LNOA1
ST_LNOA2	CLR.L	(A0)+     clear space
ST_LNOA1	DBF	D1,ST_LNOA2
	MOVEA.L	D0,A0
	RTS
;
ST_LNOB	MOVE.L	A0,PC_CS(A6)
	LEA	4(A0),A0
	MOVE.L	A0,PC_TH(A6)
	RTS
;
ST_LNOC	MOVE.L	A0,([PC_CS,A6])
	RTS
;
; ORG_N sets 'ORG;n' in BUF(A6)
;  On entry D0.W = section number 'n'
;  On exit A2 -> BUF(A6)
;
;  No registers are used
;
ORG_N	MOVEM.L	D0/D4/A0-1,-(A7)
	LEA	10+BUF(A6),A0	place for ASCII 'n'
	MOVE.L	A0,D4		prepare for count
	EXT.L	D0
	BSR	LTOD
	SUB.L	A0,D4
	MOVE.L	D4,D0
	ADDQ.W	#4,D0		total length
	MOVE.L	#'ORG;',2+BUF(A6)
	LEA	6+BUF(A6),A2
	BRA	ORG_N1
ORG_N2	MOVE.B	(A0)+,(A2)+	set 'n' -> name
ORG_N1	DBF	D4,ORG_N2
	LEA	BUF(A6),A2
	MOVE.W	D0,(A2)
	MOVEM.L	(A7)+,D0/D4/A0-1
	RTS
;
; PRERS sets BUF to print the number of ERRORs and WARNINGs
;
; It uses D0,D1,D7,A0 & A1-5
;
PRERS	LEA	BUF(A6),A1
	MOVE.W	#38,(A1)+ length of string
	MOVEQ	#9,D0
PRERS1	MOVE.L	#$20202020,(A1)+    spaces
	DBF	D0,PRERS1
	MOVE.L	#" ERR",12+BUF(A6)
	MOVE.L	#"ORs ",16+BUF(A6)
	MOVE.L	#" WAR",30+BUF(A6)
	MOVE.L	#"NING",34+BUF(A6)
	MOVE.B	#'s',38+BUF(A6)
	TST.B	BATCH(A6)
	BEQ	PRERS6
	MOVE.B	#10,39+BUF(A6)      set LF if BATCH
PRERS6	LEA	NO_ERRS(A6),A3
	LEA	18+BUF(A6),A4
	LEA	11+BUF(A6),A5
	MOVEQ	#1,D7
PRERS2	MOVEA.L	A5,A0
	LEA	18(A5),A5
	MOVE.L	(A3)+,D0  no of ERRORs then WARNINGs
	BNE.S	PRERS3
	MOVE.W	#"No",-1(A0)
	BRA.S	PRERS5
PRERS3	CMPI.L	#1,D0
	BNE.S	PRERS4
	MOVE.B	#32,(A4)
PRERS4	BSR	LTOD
PRERS5	LEA	20(A4),A4
	DBF	D7,PRERS2
	LEA	BUF(A6),A1
	RTS
;
WARN	DC.W	16
	DC.B	"        WARNING "
ERROR	DC.W	14
	DC.B	"        ERROR "
ERROR1	DC.W	32
	DC.B	"Wrong character in number/label",10
ERROR2	DC.W	17
	DC.B	"Number too large",10
ERROR3	DC.W	14
	DC.B	"EQU list full",10
ERROR4	DC.W	9
	DC.B	"No label",10
ERROR5	DC.W	17
	DC.B	"Label wrong type",10
ERROR6	DC.W	13
	DC.B	"Out of range",10
ERROR7	DC.W	18
	DC.B	"Unrecognised size",10
ERROR8	DC.W	16
	DC.B	"Too many labels",10
ERROR9	DC.W	16
	DC.B	"Wrong separator",10
ERROR10	DC.W	21
	DC.B	"Too many expressions",10
ERROR11	DC.W	17
	DC.B	"LABEL table full",10
ERROR12	DC.W	17
	DC.B	"INSERT list full",10
ERROR13	DC.W	13
	DC.B	"Reg expected",10
ERROR14	DC.W	28
	DC.B	"Incorrect Effective Address",10
ERROR15	DC.W	14
	DC.B	"Size expected",10
ERROR16	DC.W	11
	DC.B	"Wrong size",10
ERROR17	DC.W	17
	DC.B	"Operand expected",10
ERROR18	DC.W	13
	DC.B	"Illegal mode",10
ERROR19	DC.W	15
	DC.B	"Comma expected",10
ERROR20	DC.W	15
	DC.B	"Label expected",10
ERROR21	DC.W	20
	DC.B	"Illegal instruction",10
ERROR22	DC.W	18
	DC.B	"Error in reg list",10
ERROR23	DC.W	29
	DC.B	"Label defined more than once",10
ERROR24	DC.W	18
	DC.B	"Label not defined",10
ERROR25	DC.W	10
	DC.B	"Zero jump",10
ERROR26	DC.W	18
	DC.B	"Size not expected",10
ERROR27	DC.W	20
	DC.B	"Can't open LIB file",10
ERROR28	DC.W	20
	DC.B	"Can't load LIB file",10
ERROR29	DC.W	8
	DC.B	'No ENDM',10
ERROR30	DC.W	21
	DC.B	'Macro already exists',10
ERROR31	DC.W	17
	DC.B	'Faulty parameter',10
ERROR32	DC.W	20
	DC.B	'Too many parameters',10
ERROR33	DC.W	26
	DC.B	'Wrong parameter for macro',10
ERROR34	DC.W	12
	DC.B	"Wrong scale",10
ERROR35	DC.W	32
	DC.B	"Wrong character in Reg/Label/No",10
ERROR36	DC.W	14
	DC.B	"'An' expected",10
ERROR37	DC.W	13
	DC.B	"']' expected",10
ERROR38	DC.W	21
	DC.B	"Control/reg expected",10
ERROR39	DC.W	13
	DC.B	'":" expected',10
ERROR40	DC.W	13
	DC.B	'"{" expected',10
ERROR41	DC.W	13
	DC.B	'"}" expected',10
ERROR42	DC.W	13
	DC.B	'"(" expected',10
ERROR43	DC.W	13
	DC.B	'")" expected',10
ERROR44	DC.W	13
	DC.B	'FPn expected',10
ERROR45	DC.W	15
	DC.B	'FPIAR expected',10
ERROR46	DC.W	17
	DC.B	'FPcr already set',10
ERROR47	DC.W	37
	DC.B	'Arithmetic not allowed on FP numbers',10
ERROR48	DC.W	13
	DC.B	'FP list full',10
ERROR49	DC.W	17
	DC.B	'STRING list full',10
ERROR50	DC.W	17
	DC.B	"in binary number",10
ERROR51	DC.W	21
	DC.B	"Too many nested IF's",10
ERROR52	DC.W	16
	DC.B	'faulty operator',10
ERROR53	DC.W	30
	DC.B	'unmatched types of expression',10
ERROR54	DC.W	32
	DC.B	"wrong operator for FP or string",10
ERROR55	DC.W	25
	DC.B	"no operator in IF clause",10
ERROR56	DC.W	6
	DC.B	'no IF',10
ERROR57	DC.W	19
	DC.B	"more than one ELSE",10
ERROR58	DC.W	16
	DC.B	"too far from IF",10
ERROR59	DC.W	19
	DC.B	"BSR altered to NOP",10
ERROR60	DC.W	17
	DC.B	"SECTION too late",10
ERROR61	DC.W	11
	DC.B	"No SECTION",10
ERROR62	DC.W	29
	DC.B	"Label can't be XREF and XDEF",10
ERROR63	DC.W	24
	DC.B	"XREF can't be used here",10
ERROR64	DC.W	17
	DC.B	"wrong XREF label",10
ERROR65	DC.W	18
	DC.B	"Too many SECTIONs",10
ERROR66	DC.W	ERROR66E-ERROR66-2
	DC.B	"XREF labels can't be SET",10
ERROR66E	DS.B	0
ERROR67	DC.W	14
	DC.B	"in XDEF label",10
ERROR68	DC.W	20
	DC.B	"Quad word list full",10
ERROR69	DC.W	20
	DC.B	"MACRO file too long",10
ERROR70	DC.W	18
	DC.B	"Too many IN files",10
ERROR71	DC.W	E71E-ERROR71-2
	DC.B	"Too many nested MACROs"
	DC.B	" - increase Data Space",10
E71E	DS.B	0
ERROR72	DC.W	37
	DC.B	"'MACRO' instruction not allowed here",10
ERROR73	DC.W	23
	DC.B	"wrong number of FPcr's",10
	MSG	74,<'string expected '>,<,10>,ERROR
	MSG	75,<'number expected '>,<,10>,ERROR
	MSG	76,<'incorrect MACRO function'>,<,10>,ERROR
	MSG	77,<'number 1'>,<,10>,ERROR
	MSG	78,<'number 2'>,<,10>,ERROR
	MSG	79,<'number 3'>,<,10>,ERROR
	MSG	80,<'not allowed outside>,< MACRO',10>,ERROR
	MSG	81,<' no label for GOTO'>,<,10>,ERROR
	MSG	82,<'register list expected'>,<,10>,ERROR
	MSG	83,<'Option too late'>,<,10>,ERROR
	MSG	84,<'Too many labels in list'>,<,10>,ERROR
;
WARN1	DC.W	19
	DC.B	"Bcc altered to NOP",10
WARN2	DC.W	27
	DC.B	"Zero branch coded as Bcc.W",10
WARN3	DC.W	23
	DC.B	"SECTION name truncated",10
WARN4	DC.W	16
	DC.B	"Label truncated",10
WARN5	DC.W	36
	DC.B	"FP number too large - made infinite",10
WARN6	DC.W	32
	DC.B	"FP number too small - made zero",10
WARN7	DC.W	26
	DC.B	"MACRO parameter truncated",10
WARN8	DC.W	WARN8E-WARN8-2
	DC.B	"Size taken as 'W'",10
WARN8E	DS.B	0
	MSG	9,<'COMMON(SECTION) name in use by>,< SECTION(COMMON)',10>,WARN
	MSG	10,<'string insert truncated'>,<,10>,WARN
	MSG	11,<'PCs are in different >,<SECTIONS',10>,WARN
	MSG	12,<'number 1'>,<,10>,WARN
	MSG	13,<'number 2'>,<,10>,WARN
	MSG	14,<'number 3'>,<,10>,WARN
	MSG	15,<'Label for this COMMON is >,<in use',10>,WARN
	MSG	16,<'Unimplemented instruction'>,<,10>,WARN
	MSG	17,<'No label'>,<,10>,WARN
;
	DC.W	WARN17-ETB
	DC.W	WARN16-ETB
	DC.W	WARN15-ETB
	DC.W	WARN14-ETB
	DC.W	WARN13-ETB
	DC.W	WARN12-ETB
	DC.W	WARN11-ETB
	DC.W	WARN10-ETB
	DC.W	WARN9-ETB
	DC.W	WARN8-ETB
	DC.W	WARN7-ETB
	DC.W	WARN6-ETB
	DC.W	WARN5-ETB
	DC.W	WARN4-ETB
	DC.W	WARN3-ETB
	DC.W	WARN2-ETB
	DC.W	WARN1-ETB
ETB:
	EXTU	ERROR,ETB,1,84,EXT1
;
TRAIL1	DC.W	4
	DC.B	'_ASM'
TRAIL2	DC.B	'_BIN_LST_TMP_SYM'
;
BEEP2	SUBQ.W	#2,D4
	NEG.W	D4	no of OUT files to be closed - 1
	BMI	BEEP4	no OUT files to be closed
BEEP3	MOVE.L	-(A3),A0
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	DBF	D4,BEEP3
BEEP4	MOVEA.L	CH_IN(A6),A0
BEEP1	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
BEEP	BSR.S	BLP
	MOVEA.L	ID_CON(A6),A0
	TST.B	BATCH(A6)
	BEQ	REP3      not batch
	BRA	GWAG5     batch
;
BLP	LEA	NOISE,A3
	MOVEQ	#MT_IPCOM,D0
	TRAP	#1
	RTS
;
NOISE	DC.B	10,8
	DC.L	$AAAA
	DC.B	1,20,90,0,$10,$27
	DC.B	$F4,$A2,1,0
;
HEAD2	DC.W	12
	DC.B	"PASS 1      "
HEAD3	DC.W	6
	DC.B	"PASS 2"
HEAD3_B	DC.W	1
	DC.B	10
;
UMT	MOVEA.L	ID_CON(A6),A0
UMT1	MOVE.W	UT_MTEXT,A2
	JSR	(A2)
	RTS
;
AT	MOVEQ	#SD_POS,D0
TP3	TRAP	#3
TP3E	RTS
;
INK	MOVEQ	#SD_SETIN,D0
	BRA.S	TP3
;
CURON1	MOVEQ	#-1,D3
CURON	MOVEQ	#SD_CURE,D0
	BRA.S	TP4
;
CUROF1	MOVEQ	#-1,D3
CUROF	MOVEQ	#SD_CURS,D0
TP4	TST.B	DV_WMVEC(A6)
	BPL	TP3E
	BRA	TP3
;
OVER	MOVEA.L	ID_CON(A6),A0
	MOVEQ	#SD_SETMD,D0
	BRA	TP3
;
; renames the file with ID @ CH_OUT1 and sets it to the start
;
RNAM	MOVEM.L	D7/A1,-(A7)
	MOVEQ	#1,D7	count
	BRA	RNAM2
RNAM1	MOVEA.L	4(A7),A0	original name pointer
	BSR	DATA_USE	sets DATAD$&name -> A0
	MOVEA.L	A0,A1
RNAM2	MOVEA.L	CH_OUT1(A6),A0
	MOVEQ	#$4A,D0	IOF.RNAM
	BSR	TT3
	DBEQ	D7,RNAM1	if it fails 1st time try DATAD$
	BNE	QER1	---->	it fails the 2nd time!
	MOVEM.L	(A7)+,D7/A1
	MOVEQ	#0,D1	to start of file
	MOVEQ	#FS_POSAB,D0
TT3	TRAP	#3
	TST.L	D0
	RTS
